<?php



/**
 * This class defines the structure of the 'mitarbeiter' table.
 *
 *
 *
 * This map class is used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 * @package    propel.generator.propel.map
 */
class MitarbeiterTableMap extends TableMap
{

    /**
     * The (dot-path) name of this class
     */
    const CLASS_NAME = 'propel.map.MitarbeiterTableMap';

    /**
     * Initialize the table attributes, columns and validators
     * Relations are not initialized by this method since they are lazy loaded
     *
     * @return void
     * @throws PropelException
     */
    public function initialize()
    {
        // attributes
        $this->setName('mitarbeiter');
        $this->setPhpName('Mitarbeiter');
        $this->setClassname('Mitarbeiter');
        $this->setPackage('propel');
        $this->setUseIdGenerator(true);
        // columns
        $this->addPrimaryKey('id', 'Id', 'INTEGER', true, null, null);
        $this->addColumn('mod', 'Mod', 'INTEGER', true, null, null);
        $this->addColumn('nachname', 'Nachname', 'VARCHAR', true, 255, null);
        $this->addColumn('vorname', 'Vorname', 'VARCHAR', true, 255, null);
        $this->addColumn('anrede', 'Anrede', 'CHAR', true, 4, null);
        $this->addColumn('gebdat', 'Gebdat', 'DATE', true, null, null);
        $this->addColumn('soz_ver_num', 'SozVerNum', 'CHAR', true, 20, null);
        $this->addColumn('steuerid', 'Steuerid', 'CHAR', true, 20, null);
        $this->addColumn('besch_beg', 'BeschBeg', 'DATE', true, null, null);
        $this->addColumn('strasse', 'Strasse', 'VARCHAR', true, 255, null);
        $this->addColumn('plz', 'Plz', 'CHAR', true, 5, null);
        $this->addColumn('ort', 'Ort', 'VARCHAR', true, 255, null);
        $this->addColumn('iban', 'Iban', 'CHAR', true, 30, null);
        $this->addColumn('bank', 'Bank', 'VARCHAR', true, 255, null);
        $this->addColumn('email', 'Email', 'VARCHAR', true, 255, null);
        $this->addColumn('basis_betrag', 'BasisBetrag', 'NUMERIC', true, 10, 0);
        $this->addColumn('steuermerkmal', 'Steuermerkmal', 'VARCHAR', true, 30, null);
        $this->addColumn('aktiv', 'Aktiv', 'BOOLEAN', true, 1, null);
        $this->addForeignKey('lp_id', 'LpId', 'INTEGER', 'lohnprofil', 'id', true, null, null);
        // validators
    } // initialize()

    /**
     * Build the RelationMap objects for this table relationships
     */
    public function buildRelations()
    {
        $this->addRelation('Lohnprofil', 'Lohnprofil', RelationMap::MANY_TO_ONE, array('lp_id' => 'id', ), null, null);
        $this->addRelation('LA', 'Lohnabrechnung', RelationMap::ONE_TO_MANY, array('id' => 'ma_id', ), null, null, 'LAs');
    } // buildRelations()

} // MitarbeiterTableMap
