<?php


/**
 * Base class that represents a query for the 'arbeitgeberbtr' table.
 *
 *
 *
 * @method ArbeitgeberbtrQuery orderById($order = Criteria::ASC) Order by the id column
 * @method ArbeitgeberbtrQuery orderByMod($order = Criteria::ASC) Order by the mod column
 * @method ArbeitgeberbtrQuery orderByMonat($order = Criteria::ASC) Order by the monat column
 * @method ArbeitgeberbtrQuery orderByRentenversicherung($order = Criteria::ASC) Order by the rentenversicherung column
 * @method ArbeitgeberbtrQuery orderByKrankenversicherung($order = Criteria::ASC) Order by the krankenversicherung column
 * @method ArbeitgeberbtrQuery orderByU1($order = Criteria::ASC) Order by the u1 column
 * @method ArbeitgeberbtrQuery orderByU2($order = Criteria::ASC) Order by the u2 column
 * @method ArbeitgeberbtrQuery orderByInso($order = Criteria::ASC) Order by the inso column
 * @method ArbeitgeberbtrQuery orderByPauschalsteuer($order = Criteria::ASC) Order by the pauschalsteuer column
 *
 * @method ArbeitgeberbtrQuery groupById() Group by the id column
 * @method ArbeitgeberbtrQuery groupByMod() Group by the mod column
 * @method ArbeitgeberbtrQuery groupByMonat() Group by the monat column
 * @method ArbeitgeberbtrQuery groupByRentenversicherung() Group by the rentenversicherung column
 * @method ArbeitgeberbtrQuery groupByKrankenversicherung() Group by the krankenversicherung column
 * @method ArbeitgeberbtrQuery groupByU1() Group by the u1 column
 * @method ArbeitgeberbtrQuery groupByU2() Group by the u2 column
 * @method ArbeitgeberbtrQuery groupByInso() Group by the inso column
 * @method ArbeitgeberbtrQuery groupByPauschalsteuer() Group by the pauschalsteuer column
 *
 * @method ArbeitgeberbtrQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method ArbeitgeberbtrQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method ArbeitgeberbtrQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method Arbeitgeberbtr findOne(PropelPDO $con = null) Return the first Arbeitgeberbtr matching the query
 * @method Arbeitgeberbtr findOneOrCreate(PropelPDO $con = null) Return the first Arbeitgeberbtr matching the query, or a new Arbeitgeberbtr object populated from the query conditions when no match is found
 *
 * @method Arbeitgeberbtr findOneByMod(int $mod) Return the first Arbeitgeberbtr filtered by the mod column
 * @method Arbeitgeberbtr findOneByMonat(string $monat) Return the first Arbeitgeberbtr filtered by the monat column
 * @method Arbeitgeberbtr findOneByRentenversicherung(double $rentenversicherung) Return the first Arbeitgeberbtr filtered by the rentenversicherung column
 * @method Arbeitgeberbtr findOneByKrankenversicherung(double $krankenversicherung) Return the first Arbeitgeberbtr filtered by the krankenversicherung column
 * @method Arbeitgeberbtr findOneByU1(double $u1) Return the first Arbeitgeberbtr filtered by the u1 column
 * @method Arbeitgeberbtr findOneByU2(double $u2) Return the first Arbeitgeberbtr filtered by the u2 column
 * @method Arbeitgeberbtr findOneByInso(double $inso) Return the first Arbeitgeberbtr filtered by the inso column
 * @method Arbeitgeberbtr findOneByPauschalsteuer(double $pauschalsteuer) Return the first Arbeitgeberbtr filtered by the pauschalsteuer column
 *
 * @method array findById(int $id) Return Arbeitgeberbtr objects filtered by the id column
 * @method array findByMod(int $mod) Return Arbeitgeberbtr objects filtered by the mod column
 * @method array findByMonat(string $monat) Return Arbeitgeberbtr objects filtered by the monat column
 * @method array findByRentenversicherung(double $rentenversicherung) Return Arbeitgeberbtr objects filtered by the rentenversicherung column
 * @method array findByKrankenversicherung(double $krankenversicherung) Return Arbeitgeberbtr objects filtered by the krankenversicherung column
 * @method array findByU1(double $u1) Return Arbeitgeberbtr objects filtered by the u1 column
 * @method array findByU2(double $u2) Return Arbeitgeberbtr objects filtered by the u2 column
 * @method array findByInso(double $inso) Return Arbeitgeberbtr objects filtered by the inso column
 * @method array findByPauschalsteuer(double $pauschalsteuer) Return Arbeitgeberbtr objects filtered by the pauschalsteuer column
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseArbeitgeberbtrQuery extends ModelCriteria
{
    /**
     * Initializes internal state of BaseArbeitgeberbtrQuery object.
     *
     * @param     string $dbName The dabase name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = null, $modelName = null, $modelAlias = null)
    {
        if (null === $dbName) {
            $dbName = 'mlohn';
        }
        if (null === $modelName) {
            $modelName = 'Arbeitgeberbtr';
        }
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ArbeitgeberbtrQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param   ArbeitgeberbtrQuery|Criteria $criteria Optional Criteria to build the query from
     *
     * @return ArbeitgeberbtrQuery
     */
    public static function create($modelAlias = null, $criteria = null)
    {
        if ($criteria instanceof ArbeitgeberbtrQuery) {
            return $criteria;
        }
        $query = new ArbeitgeberbtrQuery(null, null, $modelAlias);

        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return   Arbeitgeberbtr|Arbeitgeberbtr[]|mixed the result, formatted by the current formatter
     */
    public function findPk($key, $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = ArbeitgeberbtrPeer::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getConnection(ArbeitgeberbtrPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Alias of findPk to use instance pooling
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 Arbeitgeberbtr A model object, or null if the key is not found
     * @throws PropelException
     */
     public function findOneById($key, $con = null)
     {
        return $this->findPk($key, $con);
     }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return                 Arbeitgeberbtr A model object, or null if the key is not found
     * @throws PropelException
     */
    protected function findPkSimple($key, $con)
    {
        $sql = 'SELECT `id`, `mod`, `monat`, `rentenversicherung`, `krankenversicherung`, `u1`, `u2`, `inso`, `pauschalsteuer` FROM `arbeitgeberbtr` WHERE `id` = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $obj = new Arbeitgeberbtr();
            $obj->hydrate($row);
            ArbeitgeberbtrPeer::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     PropelPDO $con A connection object
     *
     * @return Arbeitgeberbtr|Arbeitgeberbtr[]|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($stmt);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     PropelPDO $con an optional connection object
     *
     * @return PropelObjectCollection|Arbeitgeberbtr[]|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection($this->getDbName(), Propel::CONNECTION_READ);
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $stmt = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($stmt);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(ArbeitgeberbtrPeer::ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(ArbeitgeberbtrPeer::ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id >= 12
     * $query->filterById(array('max' => 12)); // WHERE id <= 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ArbeitgeberbtrPeer::ID, $id, $comparison);
    }

    /**
     * Filter the query on the mod column
     *
     * Example usage:
     * <code>
     * $query->filterByMod(1234); // WHERE mod = 1234
     * $query->filterByMod(array(12, 34)); // WHERE mod IN (12, 34)
     * $query->filterByMod(array('min' => 12)); // WHERE mod >= 12
     * $query->filterByMod(array('max' => 12)); // WHERE mod <= 12
     * </code>
     *
     * @param     mixed $mod The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function filterByMod($mod = null, $comparison = null)
    {
        if (is_array($mod)) {
            $useMinMax = false;
            if (isset($mod['min'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::MOD, $mod['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($mod['max'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::MOD, $mod['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ArbeitgeberbtrPeer::MOD, $mod, $comparison);
    }

    /**
     * Filter the query on the monat column
     *
     * Example usage:
     * <code>
     * $query->filterByMonat('fooValue');   // WHERE monat = 'fooValue'
     * $query->filterByMonat('%fooValue%'); // WHERE monat LIKE '%fooValue%'
     * </code>
     *
     * @param     string $monat The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function filterByMonat($monat = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($monat)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $monat)) {
                $monat = str_replace('*', '%', $monat);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(ArbeitgeberbtrPeer::MONAT, $monat, $comparison);
    }

    /**
     * Filter the query on the rentenversicherung column
     *
     * Example usage:
     * <code>
     * $query->filterByRentenversicherung(1234); // WHERE rentenversicherung = 1234
     * $query->filterByRentenversicherung(array(12, 34)); // WHERE rentenversicherung IN (12, 34)
     * $query->filterByRentenversicherung(array('min' => 12)); // WHERE rentenversicherung >= 12
     * $query->filterByRentenversicherung(array('max' => 12)); // WHERE rentenversicherung <= 12
     * </code>
     *
     * @param     mixed $rentenversicherung The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function filterByRentenversicherung($rentenversicherung = null, $comparison = null)
    {
        if (is_array($rentenversicherung)) {
            $useMinMax = false;
            if (isset($rentenversicherung['min'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::RENTENVERSICHERUNG, $rentenversicherung['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($rentenversicherung['max'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::RENTENVERSICHERUNG, $rentenversicherung['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ArbeitgeberbtrPeer::RENTENVERSICHERUNG, $rentenversicherung, $comparison);
    }

    /**
     * Filter the query on the krankenversicherung column
     *
     * Example usage:
     * <code>
     * $query->filterByKrankenversicherung(1234); // WHERE krankenversicherung = 1234
     * $query->filterByKrankenversicherung(array(12, 34)); // WHERE krankenversicherung IN (12, 34)
     * $query->filterByKrankenversicherung(array('min' => 12)); // WHERE krankenversicherung >= 12
     * $query->filterByKrankenversicherung(array('max' => 12)); // WHERE krankenversicherung <= 12
     * </code>
     *
     * @param     mixed $krankenversicherung The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function filterByKrankenversicherung($krankenversicherung = null, $comparison = null)
    {
        if (is_array($krankenversicherung)) {
            $useMinMax = false;
            if (isset($krankenversicherung['min'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::KRANKENVERSICHERUNG, $krankenversicherung['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($krankenversicherung['max'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::KRANKENVERSICHERUNG, $krankenversicherung['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ArbeitgeberbtrPeer::KRANKENVERSICHERUNG, $krankenversicherung, $comparison);
    }

    /**
     * Filter the query on the u1 column
     *
     * Example usage:
     * <code>
     * $query->filterByU1(1234); // WHERE u1 = 1234
     * $query->filterByU1(array(12, 34)); // WHERE u1 IN (12, 34)
     * $query->filterByU1(array('min' => 12)); // WHERE u1 >= 12
     * $query->filterByU1(array('max' => 12)); // WHERE u1 <= 12
     * </code>
     *
     * @param     mixed $u1 The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function filterByU1($u1 = null, $comparison = null)
    {
        if (is_array($u1)) {
            $useMinMax = false;
            if (isset($u1['min'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::U1, $u1['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($u1['max'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::U1, $u1['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ArbeitgeberbtrPeer::U1, $u1, $comparison);
    }

    /**
     * Filter the query on the u2 column
     *
     * Example usage:
     * <code>
     * $query->filterByU2(1234); // WHERE u2 = 1234
     * $query->filterByU2(array(12, 34)); // WHERE u2 IN (12, 34)
     * $query->filterByU2(array('min' => 12)); // WHERE u2 >= 12
     * $query->filterByU2(array('max' => 12)); // WHERE u2 <= 12
     * </code>
     *
     * @param     mixed $u2 The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function filterByU2($u2 = null, $comparison = null)
    {
        if (is_array($u2)) {
            $useMinMax = false;
            if (isset($u2['min'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::U2, $u2['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($u2['max'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::U2, $u2['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ArbeitgeberbtrPeer::U2, $u2, $comparison);
    }

    /**
     * Filter the query on the inso column
     *
     * Example usage:
     * <code>
     * $query->filterByInso(1234); // WHERE inso = 1234
     * $query->filterByInso(array(12, 34)); // WHERE inso IN (12, 34)
     * $query->filterByInso(array('min' => 12)); // WHERE inso >= 12
     * $query->filterByInso(array('max' => 12)); // WHERE inso <= 12
     * </code>
     *
     * @param     mixed $inso The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function filterByInso($inso = null, $comparison = null)
    {
        if (is_array($inso)) {
            $useMinMax = false;
            if (isset($inso['min'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::INSO, $inso['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($inso['max'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::INSO, $inso['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ArbeitgeberbtrPeer::INSO, $inso, $comparison);
    }

    /**
     * Filter the query on the pauschalsteuer column
     *
     * Example usage:
     * <code>
     * $query->filterByPauschalsteuer(1234); // WHERE pauschalsteuer = 1234
     * $query->filterByPauschalsteuer(array(12, 34)); // WHERE pauschalsteuer IN (12, 34)
     * $query->filterByPauschalsteuer(array('min' => 12)); // WHERE pauschalsteuer >= 12
     * $query->filterByPauschalsteuer(array('max' => 12)); // WHERE pauschalsteuer <= 12
     * </code>
     *
     * @param     mixed $pauschalsteuer The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function filterByPauschalsteuer($pauschalsteuer = null, $comparison = null)
    {
        if (is_array($pauschalsteuer)) {
            $useMinMax = false;
            if (isset($pauschalsteuer['min'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::PAUSCHALSTEUER, $pauschalsteuer['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($pauschalsteuer['max'])) {
                $this->addUsingAlias(ArbeitgeberbtrPeer::PAUSCHALSTEUER, $pauschalsteuer['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ArbeitgeberbtrPeer::PAUSCHALSTEUER, $pauschalsteuer, $comparison);
    }

    /**
     * Exclude object from result
     *
     * @param   Arbeitgeberbtr $arbeitgeberbtr Object to remove from the list of results
     *
     * @return ArbeitgeberbtrQuery The current query, for fluid interface
     */
    public function prune($arbeitgeberbtr = null)
    {
        if ($arbeitgeberbtr) {
            $this->addUsingAlias(ArbeitgeberbtrPeer::ID, $arbeitgeberbtr->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

}
