<?php


/**
 * Base static class for performing query and update operations on the 'lohnabrechnung' table.
 *
 *
 *
 * @package propel.generator.propel.om
 */
abstract class BaseLohnabrechnungPeer
{

    /** the default database name for this class */
    const DATABASE_NAME = 'mlohn';

    /** the table name for this class */
    const TABLE_NAME = 'lohnabrechnung';

    /** the related Propel class for this table */
    const OM_CLASS = 'Lohnabrechnung';

    /** the related TableMap class for this table */
    const TM_CLASS = 'LohnabrechnungTableMap';

    /** The total number of columns. */
    const NUM_COLUMNS = 16;

    /** The number of lazy-loaded columns. */
    const NUM_LAZY_LOAD_COLUMNS = 0;

    /** The number of columns to hydrate (NUM_COLUMNS - NUM_LAZY_LOAD_COLUMNS) */
    const NUM_HYDRATE_COLUMNS = 16;

    /** the column name for the id field */
    const ID = 'lohnabrechnung.id';

    /** the column name for the mod field */
    const MOD = 'lohnabrechnung.mod';

    /** the column name for the monat field */
    const MONAT = 'lohnabrechnung.monat';

    /** the column name for the arbeitsstunden field */
    const ARBEITSSTUNDEN = 'lohnabrechnung.arbeitsstunden';

    /** the column name for the brutto field */
    const BRUTTO = 'lohnabrechnung.brutto';

    /** the column name for the zulage field */
    const ZULAGE = 'lohnabrechnung.zulage';

    /** the column name for the netto field */
    const NETTO = 'lohnabrechnung.netto';

    /** the column name for the lohnsteuer field */
    const LOHNSTEUER = 'lohnabrechnung.lohnsteuer';

    /** the column name for the kirchensteuer_rk field */
    const KIRCHENSTEUER_RK = 'lohnabrechnung.kirchensteuer_rk';

    /** the column name for the kirchensteuer_ev field */
    const KIRCHENSTEUER_EV = 'lohnabrechnung.kirchensteuer_ev';

    /** the column name for the soli field */
    const SOLI = 'lohnabrechnung.soli';

    /** the column name for the rentenversicherung field */
    const RENTENVERSICHERUNG = 'lohnabrechnung.rentenversicherung';

    /** the column name for the krankenversicherung field */
    const KRANKENVERSICHERUNG = 'lohnabrechnung.krankenversicherung';

    /** the column name for the ma_id field */
    const MA_ID = 'lohnabrechnung.ma_id';

    /** the column name for the lp_id field */
    const LP_ID = 'lohnabrechnung.lp_id';

    /** the column name for the class_key field */
    const CLASS_KEY = 'lohnabrechnung.class_key';

    /** A key representing a particular subclass */
    const CLASSKEY_1 = '1';

    /** A key representing a particular subclass */
    const CLASSKEY_LOHNABRECHNUNG = '1';

    /** A class that can be returned by this peer. */
    const CLASSNAME_1 = 'Lohnabrechnung';

    /** A key representing a particular subclass */
    const CLASSKEY_2 = '2';

    /** A key representing a particular subclass */
    const CLASSKEY_LASOZIALBEFREIT = '2';

    /** A class that can be returned by this peer. */
    const CLASSNAME_2 = 'LaSozialbefreit';

    /** A key representing a particular subclass */
    const CLASSKEY_3 = '3';

    /** A key representing a particular subclass */
    const CLASSKEY_LAKURZFRIST = '3';

    /** A class that can be returned by this peer. */
    const CLASSNAME_3 = 'LaKurzfrist';

    /** A key representing a particular subclass */
    const CLASSKEY_4 = '4';

    /** A key representing a particular subclass */
    const CLASSKEY_LANORMAL = '4';

    /** A class that can be returned by this peer. */
    const CLASSNAME_4 = 'LaNormal';

    /** A key representing a particular subclass */
    const CLASSKEY_5 = '5';

    /** A key representing a particular subclass */
    const CLASSKEY_LAGERINGFUGIG = '5';

    /** A class that can be returned by this peer. */
    const CLASSNAME_5 = 'LaGeringfugig';

    /** The default string format for model objects of the related table **/
    const DEFAULT_STRING_FORMAT = 'YAML';

    /**
     * An identity map to hold any loaded instances of Lohnabrechnung objects.
     * This must be public so that other peer classes can access this when hydrating from JOIN
     * queries.
     * @var        array Lohnabrechnung[]
     */
    public static $instances = array();


    /**
     * holds an array of fieldnames
     *
     * first dimension keys are the type constants
     * e.g. LohnabrechnungPeer::$fieldNames[LohnabrechnungPeer::TYPE_PHPNAME][0] = 'Id'
     */
    protected static $fieldNames = array (
        BasePeer::TYPE_PHPNAME => array ('Id', 'Mod', 'Monat', 'Arbeitsstunden', 'Brutto', 'Zulage', 'Netto', 'Lohnsteuer', 'KirchensteuerRk', 'KirchensteuerEv', 'Soli', 'Rentenversicherung', 'Krankenversicherung', 'MaId', 'LpId', 'ClassKey', ),
        BasePeer::TYPE_STUDLYPHPNAME => array ('id', 'mod', 'monat', 'arbeitsstunden', 'brutto', 'zulage', 'netto', 'lohnsteuer', 'kirchensteuerRk', 'kirchensteuerEv', 'soli', 'rentenversicherung', 'krankenversicherung', 'maId', 'lpId', 'classKey', ),
        BasePeer::TYPE_COLNAME => array (LohnabrechnungPeer::ID, LohnabrechnungPeer::MOD, LohnabrechnungPeer::MONAT, LohnabrechnungPeer::ARBEITSSTUNDEN, LohnabrechnungPeer::BRUTTO, LohnabrechnungPeer::ZULAGE, LohnabrechnungPeer::NETTO, LohnabrechnungPeer::LOHNSTEUER, LohnabrechnungPeer::KIRCHENSTEUER_RK, LohnabrechnungPeer::KIRCHENSTEUER_EV, LohnabrechnungPeer::SOLI, LohnabrechnungPeer::RENTENVERSICHERUNG, LohnabrechnungPeer::KRANKENVERSICHERUNG, LohnabrechnungPeer::MA_ID, LohnabrechnungPeer::LP_ID, LohnabrechnungPeer::CLASS_KEY, ),
        BasePeer::TYPE_RAW_COLNAME => array ('ID', 'MOD', 'MONAT', 'ARBEITSSTUNDEN', 'BRUTTO', 'ZULAGE', 'NETTO', 'LOHNSTEUER', 'KIRCHENSTEUER_RK', 'KIRCHENSTEUER_EV', 'SOLI', 'RENTENVERSICHERUNG', 'KRANKENVERSICHERUNG', 'MA_ID', 'LP_ID', 'CLASS_KEY', ),
        BasePeer::TYPE_FIELDNAME => array ('id', 'mod', 'monat', 'arbeitsstunden', 'brutto', 'zulage', 'netto', 'lohnsteuer', 'kirchensteuer_rk', 'kirchensteuer_ev', 'soli', 'rentenversicherung', 'krankenversicherung', 'ma_id', 'lp_id', 'class_key', ),
        BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, )
    );

    /**
     * holds an array of keys for quick access to the fieldnames array
     *
     * first dimension keys are the type constants
     * e.g. LohnabrechnungPeer::$fieldNames[BasePeer::TYPE_PHPNAME]['Id'] = 0
     */
    protected static $fieldKeys = array (
        BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'Mod' => 1, 'Monat' => 2, 'Arbeitsstunden' => 3, 'Brutto' => 4, 'Zulage' => 5, 'Netto' => 6, 'Lohnsteuer' => 7, 'KirchensteuerRk' => 8, 'KirchensteuerEv' => 9, 'Soli' => 10, 'Rentenversicherung' => 11, 'Krankenversicherung' => 12, 'MaId' => 13, 'LpId' => 14, 'ClassKey' => 15, ),
        BasePeer::TYPE_STUDLYPHPNAME => array ('id' => 0, 'mod' => 1, 'monat' => 2, 'arbeitsstunden' => 3, 'brutto' => 4, 'zulage' => 5, 'netto' => 6, 'lohnsteuer' => 7, 'kirchensteuerRk' => 8, 'kirchensteuerEv' => 9, 'soli' => 10, 'rentenversicherung' => 11, 'krankenversicherung' => 12, 'maId' => 13, 'lpId' => 14, 'classKey' => 15, ),
        BasePeer::TYPE_COLNAME => array (LohnabrechnungPeer::ID => 0, LohnabrechnungPeer::MOD => 1, LohnabrechnungPeer::MONAT => 2, LohnabrechnungPeer::ARBEITSSTUNDEN => 3, LohnabrechnungPeer::BRUTTO => 4, LohnabrechnungPeer::ZULAGE => 5, LohnabrechnungPeer::NETTO => 6, LohnabrechnungPeer::LOHNSTEUER => 7, LohnabrechnungPeer::KIRCHENSTEUER_RK => 8, LohnabrechnungPeer::KIRCHENSTEUER_EV => 9, LohnabrechnungPeer::SOLI => 10, LohnabrechnungPeer::RENTENVERSICHERUNG => 11, LohnabrechnungPeer::KRANKENVERSICHERUNG => 12, LohnabrechnungPeer::MA_ID => 13, LohnabrechnungPeer::LP_ID => 14, LohnabrechnungPeer::CLASS_KEY => 15, ),
        BasePeer::TYPE_RAW_COLNAME => array ('ID' => 0, 'MOD' => 1, 'MONAT' => 2, 'ARBEITSSTUNDEN' => 3, 'BRUTTO' => 4, 'ZULAGE' => 5, 'NETTO' => 6, 'LOHNSTEUER' => 7, 'KIRCHENSTEUER_RK' => 8, 'KIRCHENSTEUER_EV' => 9, 'SOLI' => 10, 'RENTENVERSICHERUNG' => 11, 'KRANKENVERSICHERUNG' => 12, 'MA_ID' => 13, 'LP_ID' => 14, 'CLASS_KEY' => 15, ),
        BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'mod' => 1, 'monat' => 2, 'arbeitsstunden' => 3, 'brutto' => 4, 'zulage' => 5, 'netto' => 6, 'lohnsteuer' => 7, 'kirchensteuer_rk' => 8, 'kirchensteuer_ev' => 9, 'soli' => 10, 'rentenversicherung' => 11, 'krankenversicherung' => 12, 'ma_id' => 13, 'lp_id' => 14, 'class_key' => 15, ),
        BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, )
    );

    /**
     * Translates a fieldname to another type
     *
     * @param      string $name field name
     * @param      string $fromType One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                         BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
     * @param      string $toType   One of the class type constants
     * @return string          translated name of the field.
     * @throws PropelException - if the specified name could not be found in the fieldname mappings.
     */
    public static function translateFieldName($name, $fromType, $toType)
    {
        $toNames = LohnabrechnungPeer::getFieldNames($toType);
        $key = isset(LohnabrechnungPeer::$fieldKeys[$fromType][$name]) ? LohnabrechnungPeer::$fieldKeys[$fromType][$name] : null;
        if ($key === null) {
            throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(LohnabrechnungPeer::$fieldKeys[$fromType], true));
        }

        return $toNames[$key];
    }

    /**
     * Returns an array of field names.
     *
     * @param      string $type The type of fieldnames to return:
     *                      One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                      BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
     * @return array           A list of field names
     * @throws PropelException - if the type is not valid.
     */
    public static function getFieldNames($type = BasePeer::TYPE_PHPNAME)
    {
        if (!array_key_exists($type, LohnabrechnungPeer::$fieldNames)) {
            throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME, BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. ' . $type . ' was given.');
        }

        return LohnabrechnungPeer::$fieldNames[$type];
    }

    /**
     * Convenience method which changes table.column to alias.column.
     *
     * Using this method you can maintain SQL abstraction while using column aliases.
     * <code>
     *		$c->addAlias("alias1", TablePeer::TABLE_NAME);
     *		$c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
     * </code>
     * @param      string $alias The alias for the current table.
     * @param      string $column The column name for current table. (i.e. LohnabrechnungPeer::COLUMN_NAME).
     * @return string
     */
    public static function alias($alias, $column)
    {
        return str_replace(LohnabrechnungPeer::TABLE_NAME.'.', $alias.'.', $column);
    }

    /**
     * Add all the columns needed to create a new object.
     *
     * Note: any columns that were marked with lazyLoad="true" in the
     * XML schema will not be added to the select list and only loaded
     * on demand.
     *
     * @param      Criteria $criteria object containing the columns to add.
     * @param      string   $alias    optional table alias
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function addSelectColumns(Criteria $criteria, $alias = null)
    {
        if (null === $alias) {
            $criteria->addSelectColumn(LohnabrechnungPeer::ID);
            $criteria->addSelectColumn(LohnabrechnungPeer::MOD);
            $criteria->addSelectColumn(LohnabrechnungPeer::MONAT);
            $criteria->addSelectColumn(LohnabrechnungPeer::ARBEITSSTUNDEN);
            $criteria->addSelectColumn(LohnabrechnungPeer::BRUTTO);
            $criteria->addSelectColumn(LohnabrechnungPeer::ZULAGE);
            $criteria->addSelectColumn(LohnabrechnungPeer::NETTO);
            $criteria->addSelectColumn(LohnabrechnungPeer::LOHNSTEUER);
            $criteria->addSelectColumn(LohnabrechnungPeer::KIRCHENSTEUER_RK);
            $criteria->addSelectColumn(LohnabrechnungPeer::KIRCHENSTEUER_EV);
            $criteria->addSelectColumn(LohnabrechnungPeer::SOLI);
            $criteria->addSelectColumn(LohnabrechnungPeer::RENTENVERSICHERUNG);
            $criteria->addSelectColumn(LohnabrechnungPeer::KRANKENVERSICHERUNG);
            $criteria->addSelectColumn(LohnabrechnungPeer::MA_ID);
            $criteria->addSelectColumn(LohnabrechnungPeer::LP_ID);
            $criteria->addSelectColumn(LohnabrechnungPeer::CLASS_KEY);
        } else {
            $criteria->addSelectColumn($alias . '.id');
            $criteria->addSelectColumn($alias . '.mod');
            $criteria->addSelectColumn($alias . '.monat');
            $criteria->addSelectColumn($alias . '.arbeitsstunden');
            $criteria->addSelectColumn($alias . '.brutto');
            $criteria->addSelectColumn($alias . '.zulage');
            $criteria->addSelectColumn($alias . '.netto');
            $criteria->addSelectColumn($alias . '.lohnsteuer');
            $criteria->addSelectColumn($alias . '.kirchensteuer_rk');
            $criteria->addSelectColumn($alias . '.kirchensteuer_ev');
            $criteria->addSelectColumn($alias . '.soli');
            $criteria->addSelectColumn($alias . '.rentenversicherung');
            $criteria->addSelectColumn($alias . '.krankenversicherung');
            $criteria->addSelectColumn($alias . '.ma_id');
            $criteria->addSelectColumn($alias . '.lp_id');
            $criteria->addSelectColumn($alias . '.class_key');
        }
    }

    /**
     * Returns the number of rows matching criteria.
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     * @param      PropelPDO $con
     * @return int Number of matching rows.
     */
    public static function doCount(Criteria $criteria, $distinct = false, PropelPDO $con = null)
    {
        // we may modify criteria, so copy it first
        $criteria = clone $criteria;

        // We need to set the primary table name, since in the case that there are no WHERE columns
        // it will be impossible for the BasePeer::createSelectSql() method to determine which
        // tables go into the FROM clause.
        $criteria->setPrimaryTableName(LohnabrechnungPeer::TABLE_NAME);

        if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
            $criteria->setDistinct();
        }

        if (!$criteria->hasSelectClause()) {
            LohnabrechnungPeer::addSelectColumns($criteria);
        }

        $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count
        $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME); // Set the correct dbName

        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        // BasePeer returns a PDOStatement
        $stmt = BasePeer::doCount($criteria, $con);

        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $count = (int) $row[0];
        } else {
            $count = 0; // no rows returned; we infer that means 0 matches.
        }
        $stmt->closeCursor();

        return $count;
    }
    /**
     * Selects one object from the DB.
     *
     * @param      Criteria $criteria object used to create the SELECT statement.
     * @param      PropelPDO $con
     * @return Lohnabrechnung
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doSelectOne(Criteria $criteria, PropelPDO $con = null)
    {
        $critcopy = clone $criteria;
        $critcopy->setLimit(1);
        $objects = LohnabrechnungPeer::doSelect($critcopy, $con);
        if ($objects) {
            return $objects[0];
        }

        return null;
    }
    /**
     * Selects several row from the DB.
     *
     * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
     * @param      PropelPDO $con
     * @return array           Array of selected Objects
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doSelect(Criteria $criteria, PropelPDO $con = null)
    {
        return LohnabrechnungPeer::populateObjects(LohnabrechnungPeer::doSelectStmt($criteria, $con));
    }
    /**
     * Prepares the Criteria object and uses the parent doSelect() method to execute a PDOStatement.
     *
     * Use this method directly if you want to work with an executed statement directly (for example
     * to perform your own object hydration).
     *
     * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
     * @param      PropelPDO $con The connection to use
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     * @return PDOStatement The executed PDOStatement object.
     * @see        BasePeer::doSelect()
     */
    public static function doSelectStmt(Criteria $criteria, PropelPDO $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        if (!$criteria->hasSelectClause()) {
            $criteria = clone $criteria;
            LohnabrechnungPeer::addSelectColumns($criteria);
        }

        // Set the correct dbName
        $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);

        // BasePeer returns a PDOStatement
        return BasePeer::doSelect($criteria, $con);
    }
    /**
     * Adds an object to the instance pool.
     *
     * Propel keeps cached copies of objects in an instance pool when they are retrieved
     * from the database.  In some cases -- especially when you override doSelect*()
     * methods in your stub classes -- you may need to explicitly add objects
     * to the cache in order to ensure that the same objects are always returned by doSelect*()
     * and retrieveByPK*() calls.
     *
     * @param Lohnabrechnung $obj A Lohnabrechnung object.
     * @param      string $key (optional) key to use for instance map (for performance boost if key was already calculated externally).
     */
    public static function addInstanceToPool($obj, $key = null)
    {
        if (Propel::isInstancePoolingEnabled()) {
            if ($key === null) {
                $key = (string) $obj->getId();
            } // if key === null
            LohnabrechnungPeer::$instances[$key] = $obj;
        }
    }

    /**
     * Removes an object from the instance pool.
     *
     * Propel keeps cached copies of objects in an instance pool when they are retrieved
     * from the database.  In some cases -- especially when you override doDelete
     * methods in your stub classes -- you may need to explicitly remove objects
     * from the cache in order to prevent returning objects that no longer exist.
     *
     * @param      mixed $value A Lohnabrechnung object or a primary key value.
     *
     * @return void
     * @throws PropelException - if the value is invalid.
     */
    public static function removeInstanceFromPool($value)
    {
        if (Propel::isInstancePoolingEnabled() && $value !== null) {
            if (is_object($value) && $value instanceof Lohnabrechnung) {
                $key = (string) $value->getId();
            } elseif (is_scalar($value)) {
                // assume we've been passed a primary key
                $key = (string) $value;
            } else {
                $e = new PropelException("Invalid value passed to removeInstanceFromPool().  Expected primary key or Lohnabrechnung object; got " . (is_object($value) ? get_class($value) . ' object.' : var_export($value,true)));
                throw $e;
            }

            unset(LohnabrechnungPeer::$instances[$key]);
        }
    } // removeInstanceFromPool()

    /**
     * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     *
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, a serialize()d version of the primary key will be returned.
     *
     * @param      string $key The key (@see getPrimaryKeyHash()) for this instance.
     * @return Lohnabrechnung Found object or null if 1) no instance exists for specified key or 2) instance pooling has been disabled.
     * @see        getPrimaryKeyHash()
     */
    public static function getInstanceFromPool($key)
    {
        if (Propel::isInstancePoolingEnabled()) {
            if (isset(LohnabrechnungPeer::$instances[$key])) {
                return LohnabrechnungPeer::$instances[$key];
            }
        }

        return null; // just to be explicit
    }

    /**
     * Clear the instance pool.
     *
     * @return void
     */
    public static function clearInstancePool($and_clear_all_references = false)
    {
      if ($and_clear_all_references) {
        foreach (LohnabrechnungPeer::$instances as $instance) {
          $instance->clearAllReferences(true);
        }
      }
        LohnabrechnungPeer::$instances = array();
    }

    /**
     * Method to invalidate the instance pool of all tables related to lohnabrechnung
     * by a foreign key with ON DELETE CASCADE
     */
    public static function clearRelatedInstancePool()
    {
    }

    /**
     * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     *
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, a serialize()d version of the primary key will be returned.
     *
     * @param      array $row PropelPDO resultset row.
     * @param      int $startcol The 0-based offset for reading from the resultset row.
     * @return string A string version of PK or null if the components of primary key in result array are all null.
     */
    public static function getPrimaryKeyHashFromRow($row, $startcol = 0)
    {
        // If the PK cannot be derived from the row, return null.
        if ($row[$startcol] === null) {
            return null;
        }

        return (string) $row[$startcol];
    }

    /**
     * Retrieves the primary key from the DB resultset row
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, an array of the primary key columns will be returned.
     *
     * @param      array $row PropelPDO resultset row.
     * @param      int $startcol The 0-based offset for reading from the resultset row.
     * @return mixed The primary key of the row
     */
    public static function getPrimaryKeyFromRow($row, $startcol = 0)
    {

        return (int) $row[$startcol];
    }

    /**
     * The returned array will contain objects of the default type or
     * objects that inherit from the default.
     *
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function populateObjects(PDOStatement $stmt)
    {
        $results = array();

        // populate the object(s)
        while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $key = LohnabrechnungPeer::getPrimaryKeyHashFromRow($row, 0);
            if (null !== ($obj = LohnabrechnungPeer::getInstanceFromPool($key))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj->hydrate($row, 0, true); // rehydrate
                $results[] = $obj;
            } else {
                // class must be set each time from the record row
                $cls = LohnabrechnungPeer::getOMClass($row, 0);
                $cls = substr('.'.$cls, strrpos('.'.$cls, '.') + 1);
                $obj = new $cls();
                $obj->hydrate($row);
                $results[] = $obj;
                LohnabrechnungPeer::addInstanceToPool($obj, $key);
            } // if key exists
        }
        $stmt->closeCursor();

        return $results;
    }
    /**
     * Populates an object of the default type or an object that inherit from the default.
     *
     * @param      array $row PropelPDO resultset row.
     * @param      int $startcol The 0-based offset for reading from the resultset row.
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     * @return array (Lohnabrechnung object, last column rank)
     */
    public static function populateObject($row, $startcol = 0)
    {
        $key = LohnabrechnungPeer::getPrimaryKeyHashFromRow($row, $startcol);
        if (null !== ($obj = LohnabrechnungPeer::getInstanceFromPool($key))) {
            // We no longer rehydrate the object, since this can cause data loss.
            // See http://www.propelorm.org/ticket/509
            // $obj->hydrate($row, $startcol, true); // rehydrate
            $col = $startcol + LohnabrechnungPeer::NUM_HYDRATE_COLUMNS;
        } else {
            $cls = LohnabrechnungPeer::getOMClass($row, $startcol);
            $obj = new $cls();
            $col = $obj->hydrate($row, $startcol);
            LohnabrechnungPeer::addInstanceToPool($obj, $key);
        }

        return array($obj, $col);
    }


    /**
     * Returns the number of rows matching criteria, joining the related Mitarbeiter table
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     * @param      PropelPDO $con
     * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     * @return int Number of matching rows.
     */
    public static function doCountJoinMitarbeiter(Criteria $criteria, $distinct = false, PropelPDO $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        // we're going to modify criteria, so copy it first
        $criteria = clone $criteria;

        // We need to set the primary table name, since in the case that there are no WHERE columns
        // it will be impossible for the BasePeer::createSelectSql() method to determine which
        // tables go into the FROM clause.
        $criteria->setPrimaryTableName(LohnabrechnungPeer::TABLE_NAME);

        if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
            $criteria->setDistinct();
        }

        if (!$criteria->hasSelectClause()) {
            LohnabrechnungPeer::addSelectColumns($criteria);
        }

        $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count

        // Set the correct dbName
        $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);

        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        $criteria->addJoin(LohnabrechnungPeer::MA_ID, MitarbeiterPeer::ID, $join_behavior);

        $stmt = BasePeer::doCount($criteria, $con);

        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $count = (int) $row[0];
        } else {
            $count = 0; // no rows returned; we infer that means 0 matches.
        }
        $stmt->closeCursor();

        return $count;
    }


    /**
     * Returns the number of rows matching criteria, joining the related Lohnprofil table
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     * @param      PropelPDO $con
     * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     * @return int Number of matching rows.
     */
    public static function doCountJoinLohnprofil(Criteria $criteria, $distinct = false, PropelPDO $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        // we're going to modify criteria, so copy it first
        $criteria = clone $criteria;

        // We need to set the primary table name, since in the case that there are no WHERE columns
        // it will be impossible for the BasePeer::createSelectSql() method to determine which
        // tables go into the FROM clause.
        $criteria->setPrimaryTableName(LohnabrechnungPeer::TABLE_NAME);

        if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
            $criteria->setDistinct();
        }

        if (!$criteria->hasSelectClause()) {
            LohnabrechnungPeer::addSelectColumns($criteria);
        }

        $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count

        // Set the correct dbName
        $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);

        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        $criteria->addJoin(LohnabrechnungPeer::LP_ID, LohnprofilPeer::ID, $join_behavior);

        $stmt = BasePeer::doCount($criteria, $con);

        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $count = (int) $row[0];
        } else {
            $count = 0; // no rows returned; we infer that means 0 matches.
        }
        $stmt->closeCursor();

        return $count;
    }


    /**
     * Selects a collection of Lohnabrechnung objects pre-filled with their Mitarbeiter objects.
     * @param      Criteria  $criteria
     * @param      PropelPDO $con
     * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     * @return array           Array of Lohnabrechnung objects.
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doSelectJoinMitarbeiter(Criteria $criteria, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $criteria = clone $criteria;

        // Set the correct dbName if it has not been overridden
        if ($criteria->getDbName() == Propel::getDefaultDB()) {
            $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);
        }

        LohnabrechnungPeer::addSelectColumns($criteria);
        $startcol = LohnabrechnungPeer::NUM_HYDRATE_COLUMNS;
        MitarbeiterPeer::addSelectColumns($criteria);

        $criteria->addJoin(LohnabrechnungPeer::MA_ID, MitarbeiterPeer::ID, $join_behavior);

        $stmt = BasePeer::doSelect($criteria, $con);
        $results = array();

        while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $key1 = LohnabrechnungPeer::getPrimaryKeyHashFromRow($row, 0);
            if (null !== ($obj1 = LohnabrechnungPeer::getInstanceFromPool($key1))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj1->hydrate($row, 0, true); // rehydrate
            } else {

                $omClass = LohnabrechnungPeer::getOMClass($row, 0);
                $cls = substr('.'.$omClass, strrpos('.'.$omClass, '.') + 1);

                $obj1 = new $cls();
                $obj1->hydrate($row);
                LohnabrechnungPeer::addInstanceToPool($obj1, $key1);
            } // if $obj1 already loaded

            $key2 = MitarbeiterPeer::getPrimaryKeyHashFromRow($row, $startcol);
            if ($key2 !== null) {
                $obj2 = MitarbeiterPeer::getInstanceFromPool($key2);
                if (!$obj2) {

                    $cls = MitarbeiterPeer::getOMClass();

                    $obj2 = new $cls();
                    $obj2->hydrate($row, $startcol);
                    MitarbeiterPeer::addInstanceToPool($obj2, $key2);
                } // if obj2 already loaded

                // Add the $obj1 (Lohnabrechnung) to $obj2 (Mitarbeiter)
                $obj2->addLA($obj1);

            } // if joined row was not null

            $results[] = $obj1;
        }
        $stmt->closeCursor();

        return $results;
    }


    /**
     * Selects a collection of Lohnabrechnung objects pre-filled with their Lohnprofil objects.
     * @param      Criteria  $criteria
     * @param      PropelPDO $con
     * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     * @return array           Array of Lohnabrechnung objects.
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doSelectJoinLohnprofil(Criteria $criteria, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $criteria = clone $criteria;

        // Set the correct dbName if it has not been overridden
        if ($criteria->getDbName() == Propel::getDefaultDB()) {
            $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);
        }

        LohnabrechnungPeer::addSelectColumns($criteria);
        $startcol = LohnabrechnungPeer::NUM_HYDRATE_COLUMNS;
        LohnprofilPeer::addSelectColumns($criteria);

        $criteria->addJoin(LohnabrechnungPeer::LP_ID, LohnprofilPeer::ID, $join_behavior);

        $stmt = BasePeer::doSelect($criteria, $con);
        $results = array();

        while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $key1 = LohnabrechnungPeer::getPrimaryKeyHashFromRow($row, 0);
            if (null !== ($obj1 = LohnabrechnungPeer::getInstanceFromPool($key1))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj1->hydrate($row, 0, true); // rehydrate
            } else {

                $omClass = LohnabrechnungPeer::getOMClass($row, 0);
                $cls = substr('.'.$omClass, strrpos('.'.$omClass, '.') + 1);

                $obj1 = new $cls();
                $obj1->hydrate($row);
                LohnabrechnungPeer::addInstanceToPool($obj1, $key1);
            } // if $obj1 already loaded

            $key2 = LohnprofilPeer::getPrimaryKeyHashFromRow($row, $startcol);
            if ($key2 !== null) {
                $obj2 = LohnprofilPeer::getInstanceFromPool($key2);
                if (!$obj2) {

                    $cls = LohnprofilPeer::getOMClass();

                    $obj2 = new $cls();
                    $obj2->hydrate($row, $startcol);
                    LohnprofilPeer::addInstanceToPool($obj2, $key2);
                } // if obj2 already loaded

                // Add the $obj1 (Lohnabrechnung) to $obj2 (Lohnprofil)
                $obj2->addLA($obj1);

            } // if joined row was not null

            $results[] = $obj1;
        }
        $stmt->closeCursor();

        return $results;
    }


    /**
     * Returns the number of rows matching criteria, joining all related tables
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     * @param      PropelPDO $con
     * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     * @return int Number of matching rows.
     */
    public static function doCountJoinAll(Criteria $criteria, $distinct = false, PropelPDO $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        // we're going to modify criteria, so copy it first
        $criteria = clone $criteria;

        // We need to set the primary table name, since in the case that there are no WHERE columns
        // it will be impossible for the BasePeer::createSelectSql() method to determine which
        // tables go into the FROM clause.
        $criteria->setPrimaryTableName(LohnabrechnungPeer::TABLE_NAME);

        if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
            $criteria->setDistinct();
        }

        if (!$criteria->hasSelectClause()) {
            LohnabrechnungPeer::addSelectColumns($criteria);
        }

        $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count

        // Set the correct dbName
        $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);

        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        $criteria->addJoin(LohnabrechnungPeer::MA_ID, MitarbeiterPeer::ID, $join_behavior);

        $criteria->addJoin(LohnabrechnungPeer::LP_ID, LohnprofilPeer::ID, $join_behavior);

        $stmt = BasePeer::doCount($criteria, $con);

        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $count = (int) $row[0];
        } else {
            $count = 0; // no rows returned; we infer that means 0 matches.
        }
        $stmt->closeCursor();

        return $count;
    }

    /**
     * Selects a collection of Lohnabrechnung objects pre-filled with all related objects.
     *
     * @param      Criteria  $criteria
     * @param      PropelPDO $con
     * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     * @return array           Array of Lohnabrechnung objects.
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doSelectJoinAll(Criteria $criteria, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $criteria = clone $criteria;

        // Set the correct dbName if it has not been overridden
        if ($criteria->getDbName() == Propel::getDefaultDB()) {
            $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);
        }

        LohnabrechnungPeer::addSelectColumns($criteria);
        $startcol2 = LohnabrechnungPeer::NUM_HYDRATE_COLUMNS;

        MitarbeiterPeer::addSelectColumns($criteria);
        $startcol3 = $startcol2 + MitarbeiterPeer::NUM_HYDRATE_COLUMNS;

        LohnprofilPeer::addSelectColumns($criteria);
        $startcol4 = $startcol3 + LohnprofilPeer::NUM_HYDRATE_COLUMNS;

        $criteria->addJoin(LohnabrechnungPeer::MA_ID, MitarbeiterPeer::ID, $join_behavior);

        $criteria->addJoin(LohnabrechnungPeer::LP_ID, LohnprofilPeer::ID, $join_behavior);

        $stmt = BasePeer::doSelect($criteria, $con);
        $results = array();

        while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $key1 = LohnabrechnungPeer::getPrimaryKeyHashFromRow($row, 0);
            if (null !== ($obj1 = LohnabrechnungPeer::getInstanceFromPool($key1))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj1->hydrate($row, 0, true); // rehydrate
            } else {
                $omClass = LohnabrechnungPeer::getOMClass($row, 0);
        $cls = substr('.'.$omClass, strrpos('.'.$omClass, '.') + 1);

                $obj1 = new $cls();
                $obj1->hydrate($row);
                LohnabrechnungPeer::addInstanceToPool($obj1, $key1);
            } // if obj1 already loaded

            // Add objects for joined Mitarbeiter rows

            $key2 = MitarbeiterPeer::getPrimaryKeyHashFromRow($row, $startcol2);
            if ($key2 !== null) {
                $obj2 = MitarbeiterPeer::getInstanceFromPool($key2);
                if (!$obj2) {

                    $cls = MitarbeiterPeer::getOMClass();

                    $obj2 = new $cls();
                    $obj2->hydrate($row, $startcol2);
                    MitarbeiterPeer::addInstanceToPool($obj2, $key2);
                } // if obj2 loaded

                // Add the $obj1 (Lohnabrechnung) to the collection in $obj2 (Mitarbeiter)
                $obj2->addLA($obj1);
            } // if joined row not null

            // Add objects for joined Lohnprofil rows

            $key3 = LohnprofilPeer::getPrimaryKeyHashFromRow($row, $startcol3);
            if ($key3 !== null) {
                $obj3 = LohnprofilPeer::getInstanceFromPool($key3);
                if (!$obj3) {

                    $cls = LohnprofilPeer::getOMClass();

                    $obj3 = new $cls();
                    $obj3->hydrate($row, $startcol3);
                    LohnprofilPeer::addInstanceToPool($obj3, $key3);
                } // if obj3 loaded

                // Add the $obj1 (Lohnabrechnung) to the collection in $obj3 (Lohnprofil)
                $obj3->addLA($obj1);
            } // if joined row not null

            $results[] = $obj1;
        }
        $stmt->closeCursor();

        return $results;
    }


    /**
     * Returns the number of rows matching criteria, joining the related Mitarbeiter table
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     * @param      PropelPDO $con
     * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     * @return int Number of matching rows.
     */
    public static function doCountJoinAllExceptMitarbeiter(Criteria $criteria, $distinct = false, PropelPDO $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        // we're going to modify criteria, so copy it first
        $criteria = clone $criteria;

        // We need to set the primary table name, since in the case that there are no WHERE columns
        // it will be impossible for the BasePeer::createSelectSql() method to determine which
        // tables go into the FROM clause.
        $criteria->setPrimaryTableName(LohnabrechnungPeer::TABLE_NAME);

        if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
            $criteria->setDistinct();
        }

        if (!$criteria->hasSelectClause()) {
            LohnabrechnungPeer::addSelectColumns($criteria);
        }

        $criteria->clearOrderByColumns(); // ORDER BY should not affect count

        // Set the correct dbName
        $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);

        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        $criteria->addJoin(LohnabrechnungPeer::LP_ID, LohnprofilPeer::ID, $join_behavior);

        $stmt = BasePeer::doCount($criteria, $con);

        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $count = (int) $row[0];
        } else {
            $count = 0; // no rows returned; we infer that means 0 matches.
        }
        $stmt->closeCursor();

        return $count;
    }


    /**
     * Returns the number of rows matching criteria, joining the related Lohnprofil table
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     * @param      PropelPDO $con
     * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     * @return int Number of matching rows.
     */
    public static function doCountJoinAllExceptLohnprofil(Criteria $criteria, $distinct = false, PropelPDO $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        // we're going to modify criteria, so copy it first
        $criteria = clone $criteria;

        // We need to set the primary table name, since in the case that there are no WHERE columns
        // it will be impossible for the BasePeer::createSelectSql() method to determine which
        // tables go into the FROM clause.
        $criteria->setPrimaryTableName(LohnabrechnungPeer::TABLE_NAME);

        if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
            $criteria->setDistinct();
        }

        if (!$criteria->hasSelectClause()) {
            LohnabrechnungPeer::addSelectColumns($criteria);
        }

        $criteria->clearOrderByColumns(); // ORDER BY should not affect count

        // Set the correct dbName
        $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);

        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        $criteria->addJoin(LohnabrechnungPeer::MA_ID, MitarbeiterPeer::ID, $join_behavior);

        $stmt = BasePeer::doCount($criteria, $con);

        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $count = (int) $row[0];
        } else {
            $count = 0; // no rows returned; we infer that means 0 matches.
        }
        $stmt->closeCursor();

        return $count;
    }


    /**
     * Selects a collection of Lohnabrechnung objects pre-filled with all related objects except Mitarbeiter.
     *
     * @param      Criteria  $criteria
     * @param      PropelPDO $con
     * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     * @return array           Array of Lohnabrechnung objects.
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doSelectJoinAllExceptMitarbeiter(Criteria $criteria, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $criteria = clone $criteria;

        // Set the correct dbName if it has not been overridden
        // $criteria->getDbName() will return the same object if not set to another value
        // so == check is okay and faster
        if ($criteria->getDbName() == Propel::getDefaultDB()) {
            $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);
        }

        LohnabrechnungPeer::addSelectColumns($criteria);
        $startcol2 = LohnabrechnungPeer::NUM_HYDRATE_COLUMNS;

        LohnprofilPeer::addSelectColumns($criteria);
        $startcol3 = $startcol2 + LohnprofilPeer::NUM_HYDRATE_COLUMNS;

        $criteria->addJoin(LohnabrechnungPeer::LP_ID, LohnprofilPeer::ID, $join_behavior);


        $stmt = BasePeer::doSelect($criteria, $con);
        $results = array();

        while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $key1 = LohnabrechnungPeer::getPrimaryKeyHashFromRow($row, 0);
            if (null !== ($obj1 = LohnabrechnungPeer::getInstanceFromPool($key1))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj1->hydrate($row, 0, true); // rehydrate
            } else {
                $omClass = LohnabrechnungPeer::getOMClass($row, 0);
                $cls = substr('.'.$omClass, strrpos('.'.$omClass, '.') + 1);

                $obj1 = new $cls();
                $obj1->hydrate($row);
                LohnabrechnungPeer::addInstanceToPool($obj1, $key1);
            } // if obj1 already loaded

                // Add objects for joined Lohnprofil rows

                $key2 = LohnprofilPeer::getPrimaryKeyHashFromRow($row, $startcol2);
                if ($key2 !== null) {
                    $obj2 = LohnprofilPeer::getInstanceFromPool($key2);
                    if (!$obj2) {

                        $cls = LohnprofilPeer::getOMClass();

                    $obj2 = new $cls();
                    $obj2->hydrate($row, $startcol2);
                    LohnprofilPeer::addInstanceToPool($obj2, $key2);
                } // if $obj2 already loaded

                // Add the $obj1 (Lohnabrechnung) to the collection in $obj2 (Lohnprofil)
                $obj2->addLA($obj1);

            } // if joined row is not null

            $results[] = $obj1;
        }
        $stmt->closeCursor();

        return $results;
    }


    /**
     * Selects a collection of Lohnabrechnung objects pre-filled with all related objects except Lohnprofil.
     *
     * @param      Criteria  $criteria
     * @param      PropelPDO $con
     * @param      String    $join_behavior the type of joins to use, defaults to Criteria::LEFT_JOIN
     * @return array           Array of Lohnabrechnung objects.
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doSelectJoinAllExceptLohnprofil(Criteria $criteria, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $criteria = clone $criteria;

        // Set the correct dbName if it has not been overridden
        // $criteria->getDbName() will return the same object if not set to another value
        // so == check is okay and faster
        if ($criteria->getDbName() == Propel::getDefaultDB()) {
            $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);
        }

        LohnabrechnungPeer::addSelectColumns($criteria);
        $startcol2 = LohnabrechnungPeer::NUM_HYDRATE_COLUMNS;

        MitarbeiterPeer::addSelectColumns($criteria);
        $startcol3 = $startcol2 + MitarbeiterPeer::NUM_HYDRATE_COLUMNS;

        $criteria->addJoin(LohnabrechnungPeer::MA_ID, MitarbeiterPeer::ID, $join_behavior);


        $stmt = BasePeer::doSelect($criteria, $con);
        $results = array();

        while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $key1 = LohnabrechnungPeer::getPrimaryKeyHashFromRow($row, 0);
            if (null !== ($obj1 = LohnabrechnungPeer::getInstanceFromPool($key1))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj1->hydrate($row, 0, true); // rehydrate
            } else {
                $omClass = LohnabrechnungPeer::getOMClass($row, 0);
                $cls = substr('.'.$omClass, strrpos('.'.$omClass, '.') + 1);

                $obj1 = new $cls();
                $obj1->hydrate($row);
                LohnabrechnungPeer::addInstanceToPool($obj1, $key1);
            } // if obj1 already loaded

                // Add objects for joined Mitarbeiter rows

                $key2 = MitarbeiterPeer::getPrimaryKeyHashFromRow($row, $startcol2);
                if ($key2 !== null) {
                    $obj2 = MitarbeiterPeer::getInstanceFromPool($key2);
                    if (!$obj2) {

                        $cls = MitarbeiterPeer::getOMClass();

                    $obj2 = new $cls();
                    $obj2->hydrate($row, $startcol2);
                    MitarbeiterPeer::addInstanceToPool($obj2, $key2);
                } // if $obj2 already loaded

                // Add the $obj1 (Lohnabrechnung) to the collection in $obj2 (Mitarbeiter)
                $obj2->addLA($obj1);

            } // if joined row is not null

            $results[] = $obj1;
        }
        $stmt->closeCursor();

        return $results;
    }

    /**
     * Returns the TableMap related to this peer.
     * This method is not needed for general use but a specific application could have a need.
     * @return TableMap
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function getTableMap()
    {
        return Propel::getDatabaseMap(LohnabrechnungPeer::DATABASE_NAME)->getTable(LohnabrechnungPeer::TABLE_NAME);
    }

    /**
     * Add a TableMap instance to the database for this peer class.
     */
    public static function buildTableMap()
    {
      $dbMap = Propel::getDatabaseMap(BaseLohnabrechnungPeer::DATABASE_NAME);
      if (!$dbMap->hasTable(BaseLohnabrechnungPeer::TABLE_NAME)) {
        $dbMap->addTableObject(new \LohnabrechnungTableMap());
      }
    }

    /**
     * The returned Class will contain objects of the default type or
     * objects that inherit from the default.
     *
     * @param      array $row PropelPDO result row.
     * @param      int $colnum Column to examine for OM class information (first is 0).
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function getOMClass($row = 0, $colnum = 0)
    {
        try {

            $omClass = null;
            $classKey = $row[$colnum + 15];

            switch ($classKey) {

                case LohnabrechnungPeer::CLASSKEY_1:
                    $omClass = LohnabrechnungPeer::CLASSNAME_1;
                    break;

                case LohnabrechnungPeer::CLASSKEY_2:
                    $omClass = LohnabrechnungPeer::CLASSNAME_2;
                    break;

                case LohnabrechnungPeer::CLASSKEY_3:
                    $omClass = LohnabrechnungPeer::CLASSNAME_3;
                    break;

                case LohnabrechnungPeer::CLASSKEY_4:
                    $omClass = LohnabrechnungPeer::CLASSNAME_4;
                    break;

                case LohnabrechnungPeer::CLASSKEY_5:
                    $omClass = LohnabrechnungPeer::CLASSNAME_5;
                    break;

                default:
                    $omClass = LohnabrechnungPeer::OM_CLASS;

            } // switch

        } catch (Exception $e) {
            throw new PropelException('Unable to get OM class.', $e);
        }

        return $omClass;
    }

    /**
     * Performs an INSERT on the database, given a Lohnabrechnung or Criteria object.
     *
     * @param      mixed $values Criteria or Lohnabrechnung object containing data that is used to create the INSERT statement.
     * @param      PropelPDO $con the PropelPDO connection to use
     * @return mixed           The new primary key.
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doInsert($values, PropelPDO $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        if ($values instanceof Criteria) {
            $criteria = clone $values; // rename for clarity
        } else {
            $criteria = $values->buildCriteria(); // build Criteria from Lohnabrechnung object
        }

        if ($criteria->containsKey(LohnabrechnungPeer::ID) && $criteria->keyContainsValue(LohnabrechnungPeer::ID) ) {
            throw new PropelException('Cannot insert a value for auto-increment primary key ('.LohnabrechnungPeer::ID.')');
        }


        // Set the correct dbName
        $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);

        try {
            // use transaction because $criteria could contain info
            // for more than one table (I guess, conceivably)
            $con->beginTransaction();
            $pk = BasePeer::doInsert($criteria, $con);
            $con->commit();
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }

        return $pk;
    }

    /**
     * Performs an UPDATE on the database, given a Lohnabrechnung or Criteria object.
     *
     * @param      mixed $values Criteria or Lohnabrechnung object containing data that is used to create the UPDATE statement.
     * @param      PropelPDO $con The connection to use (specify PropelPDO connection object to exert more control over transactions).
     * @return int             The number of affected rows (if supported by underlying database driver).
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doUpdate($values, PropelPDO $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $selectCriteria = new Criteria(LohnabrechnungPeer::DATABASE_NAME);

        if ($values instanceof Criteria) {
            $criteria = clone $values; // rename for clarity

            $comparison = $criteria->getComparison(LohnabrechnungPeer::ID);
            $value = $criteria->remove(LohnabrechnungPeer::ID);
            if ($value) {
                $selectCriteria->add(LohnabrechnungPeer::ID, $value, $comparison);
            } else {
                $selectCriteria->setPrimaryTableName(LohnabrechnungPeer::TABLE_NAME);
            }

        } else { // $values is Lohnabrechnung object
            $criteria = $values->buildCriteria(); // gets full criteria
            $selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)
        }

        // set the correct dbName
        $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);

        return BasePeer::doUpdate($selectCriteria, $criteria, $con);
    }

    /**
     * Deletes all rows from the lohnabrechnung table.
     *
     * @param      PropelPDO $con the connection to use
     * @return int             The number of affected rows (if supported by underlying database driver).
     * @throws PropelException
     */
    public static function doDeleteAll(PropelPDO $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }
        $affectedRows = 0; // initialize var to track total num of affected rows
        try {
            // use transaction because $criteria could contain info
            // for more than one table or we could emulating ON DELETE CASCADE, etc.
            $con->beginTransaction();
            $affectedRows += BasePeer::doDeleteAll(LohnabrechnungPeer::TABLE_NAME, $con, LohnabrechnungPeer::DATABASE_NAME);
            // Because this db requires some delete cascade/set null emulation, we have to
            // clear the cached instance *after* the emulation has happened (since
            // instances get re-added by the select statement contained therein).
            LohnabrechnungPeer::clearInstancePool();
            LohnabrechnungPeer::clearRelatedInstancePool();
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs a DELETE on the database, given a Lohnabrechnung or Criteria object OR a primary key value.
     *
     * @param      mixed $values Criteria or Lohnabrechnung object or primary key or array of primary keys
     *              which is used to create the DELETE statement
     * @param      PropelPDO $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *				if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
     public static function doDelete($values, PropelPDO $con = null)
     {
        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        if ($values instanceof Criteria) {
            // invalidate the cache for all objects of this type, since we have no
            // way of knowing (without running a query) what objects should be invalidated
            // from the cache based on this Criteria.
            LohnabrechnungPeer::clearInstancePool();
            // rename for clarity
            $criteria = clone $values;
        } elseif ($values instanceof Lohnabrechnung) { // it's a model object
            // invalidate the cache for this single object
            LohnabrechnungPeer::removeInstanceFromPool($values);
            // create criteria based on pk values
            $criteria = $values->buildPkeyCriteria();
        } else { // it's a primary key, or an array of pks
            $criteria = new Criteria(LohnabrechnungPeer::DATABASE_NAME);
            $criteria->add(LohnabrechnungPeer::ID, (array) $values, Criteria::IN);
            // invalidate the cache for this object(s)
            foreach ((array) $values as $singleval) {
                LohnabrechnungPeer::removeInstanceFromPool($singleval);
            }
        }

        // Set the correct dbName
        $criteria->setDbName(LohnabrechnungPeer::DATABASE_NAME);

        $affectedRows = 0; // initialize var to track total num of affected rows

        try {
            // use transaction because $criteria could contain info
            // for more than one table or we could emulating ON DELETE CASCADE, etc.
            $con->beginTransaction();

            $affectedRows += BasePeer::doDelete($criteria, $con);
            LohnabrechnungPeer::clearRelatedInstancePool();
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Validates all modified columns of given Lohnabrechnung object.
     * If parameter $columns is either a single column name or an array of column names
     * than only those columns are validated.
     *
     * NOTICE: This does not apply to primary or foreign keys for now.
     *
     * @param Lohnabrechnung $obj The object to validate.
     * @param      mixed $cols Column name or array of column names.
     *
     * @return mixed TRUE if all columns are valid or the error message of the first invalid column.
     */
    public static function doValidate($obj, $cols = null)
    {
        $columns = array();

        if ($cols) {
            $dbMap = Propel::getDatabaseMap(LohnabrechnungPeer::DATABASE_NAME);
            $tableMap = $dbMap->getTable(LohnabrechnungPeer::TABLE_NAME);

            if (! is_array($cols)) {
                $cols = array($cols);
            }

            foreach ($cols as $colName) {
                if ($tableMap->hasColumn($colName)) {
                    $get = 'get' . $tableMap->getColumn($colName)->getPhpName();
                    $columns[$colName] = $obj->$get();
                }
            }
        } else {

        }

        return BasePeer::doValidate(LohnabrechnungPeer::DATABASE_NAME, LohnabrechnungPeer::TABLE_NAME, $columns);
    }

    /**
     * Retrieve a single object by pkey.
     *
     * @param int $pk the primary key.
     * @param      PropelPDO $con the connection to use
     * @return Lohnabrechnung
     */
    public static function retrieveByPK($pk, PropelPDO $con = null)
    {

        if (null !== ($obj = LohnabrechnungPeer::getInstanceFromPool((string) $pk))) {
            return $obj;
        }

        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        $criteria = new Criteria(LohnabrechnungPeer::DATABASE_NAME);
        $criteria->add(LohnabrechnungPeer::ID, $pk);

        $v = LohnabrechnungPeer::doSelect($criteria, $con);

        return !empty($v) > 0 ? $v[0] : null;
    }

    /**
     * Retrieve multiple objects by pkey.
     *
     * @param      array $pks List of primary keys
     * @param      PropelPDO $con the connection to use
     * @return Lohnabrechnung[]
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function retrieveByPKs($pks, PropelPDO $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        $objs = null;
        if (empty($pks)) {
            $objs = array();
        } else {
            $criteria = new Criteria(LohnabrechnungPeer::DATABASE_NAME);
            $criteria->add(LohnabrechnungPeer::ID, $pks, Criteria::IN);
            $objs = LohnabrechnungPeer::doSelect($criteria, $con);
        }

        return $objs;
    }

} // BaseLohnabrechnungPeer

// This is the static code needed to register the TableMap for this table with the main Propel class.
//
BaseLohnabrechnungPeer::buildTableMap();

