<?php


/**
 * Base class that represents a row from the 'mitarbeiter' table.
 *
 *
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseMitarbeiter extends BaseObject implements Persistent
{
    /**
     * Peer class name
     */
    const PEER = 'MitarbeiterPeer';

    /**
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var        MitarbeiterPeer
     */
    protected static $peer;

    /**
     * The flag var to prevent infinite loop in deep copy
     * @var       boolean
     */
    protected $startCopy = false;

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the mod field.
     * @var        int
     */
    protected $mod;

    /**
     * The value for the nachname field.
     * @var        string
     */
    protected $nachname;

    /**
     * The value for the vorname field.
     * @var        string
     */
    protected $vorname;

    /**
     * The value for the anrede field.
     * @var        string
     */
    protected $anrede;

    /**
     * The value for the gebdat field.
     * @var        string
     */
    protected $gebdat;

    /**
     * The value for the soz_ver_num field.
     * @var        string
     */
    protected $soz_ver_num;

    /**
     * The value for the steuerid field.
     * @var        string
     */
    protected $steuerid;

    /**
     * The value for the besch_beg field.
     * @var        string
     */
    protected $besch_beg;

    /**
     * The value for the strasse field.
     * @var        string
     */
    protected $strasse;

    /**
     * The value for the plz field.
     * @var        string
     */
    protected $plz;

    /**
     * The value for the ort field.
     * @var        string
     */
    protected $ort;

    /**
     * The value for the iban field.
     * @var        string
     */
    protected $iban;

    /**
     * The value for the bank field.
     * @var        string
     */
    protected $bank;

    /**
     * The value for the email field.
     * @var        string
     */
    protected $email;

    /**
     * The value for the basis_betrag field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $basis_betrag;

    /**
     * The value for the steuermerkmal field.
     * @var        string
     */
    protected $steuermerkmal;

    /**
     * The value for the aktiv field.
     * @var        boolean
     */
    protected $aktiv;

    /**
     * The value for the lp_id field.
     * @var        int
     */
    protected $lp_id;

    /**
     * @var        Lohnprofil
     */
    protected $aLohnprofil;

    /**
     * @var        PropelObjectCollection|Lohnabrechnung[] Collection to store aggregation of Lohnabrechnung objects.
     */
    protected $collLAs;
    protected $collLAsPartial;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInSave = false;

    /**
     * Flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInValidation = false;

    /**
     * Flag to prevent endless clearAllReferences($deep=true) loop, if this object is referenced
     * @var        boolean
     */
    protected $alreadyInClearAllReferencesDeep = false;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $lAsScheduledForDeletion = null;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see        __construct()
     */
    public function applyDefaultValues()
    {
        $this->basis_betrag = '0';
    }

    /**
     * Initializes internal state of BaseMitarbeiter object.
     * @see        applyDefaults()
     */
    public function __construct()
    {
        parent::__construct();
        $this->applyDefaultValues();
    }

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {

        return $this->id;
    }

    /**
     * Get the [mod] column value.
     *
     * @return int
     */
    public function getMod()
    {

        return $this->mod;
    }

    /**
     * Get the [nachname] column value.
     *
     * @return string
     */
    public function getNachname()
    {

        return $this->nachname;
    }

    /**
     * Get the [vorname] column value.
     *
     * @return string
     */
    public function getVorname()
    {

        return $this->vorname;
    }

    /**
     * Get the [anrede] column value.
     *
     * @return string
     */
    public function getAnrede()
    {

        return $this->anrede;
    }

    /**
     * Get the [optionally formatted] temporal [gebdat] column value.
     *
     *
     * @param string $format The date/time format string (either date()-style or strftime()-style).
     *				 If format is null, then the raw DateTime object will be returned.
     * @return mixed Formatted date/time value as string or DateTime object (if format is null), null if column is null, and 0 if column value is 0000-00-00
     * @throws PropelException - if unable to parse/validate the date/time value.
     */
    public function getGebdat($format = '%x')
    {
        if ($this->gebdat === null) {
            return null;
        }

        if ($this->gebdat === '0000-00-00') {
            // while technically this is not a default value of null,
            // this seems to be closest in meaning.
            return null;
        }

        try {
            $dt = new DateTime($this->gebdat);
        } catch (Exception $x) {
            throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->gebdat, true), $x);
        }

        if ($format === null) {
            // Because propel.useDateTimeClass is true, we return a DateTime object.
            return $dt;
        }

        if (strpos($format, '%') !== false) {
            return strftime($format, $dt->format('U'));
        }

        return $dt->format($format);

    }

    /**
     * Get the [soz_ver_num] column value.
     *
     * @return string
     */
    public function getSozVerNum()
    {

        return $this->soz_ver_num;
    }

    /**
     * Get the [steuerid] column value.
     *
     * @return string
     */
    public function getSteuerid()
    {

        return $this->steuerid;
    }

    /**
     * Get the [optionally formatted] temporal [besch_beg] column value.
     *
     *
     * @param string $format The date/time format string (either date()-style or strftime()-style).
     *				 If format is null, then the raw DateTime object will be returned.
     * @return mixed Formatted date/time value as string or DateTime object (if format is null), null if column is null, and 0 if column value is 0000-00-00
     * @throws PropelException - if unable to parse/validate the date/time value.
     */
    public function getBeschBeg($format = '%x')
    {
        if ($this->besch_beg === null) {
            return null;
        }

        if ($this->besch_beg === '0000-00-00') {
            // while technically this is not a default value of null,
            // this seems to be closest in meaning.
            return null;
        }

        try {
            $dt = new DateTime($this->besch_beg);
        } catch (Exception $x) {
            throw new PropelException("Internally stored date/time/timestamp value could not be converted to DateTime: " . var_export($this->besch_beg, true), $x);
        }

        if ($format === null) {
            // Because propel.useDateTimeClass is true, we return a DateTime object.
            return $dt;
        }

        if (strpos($format, '%') !== false) {
            return strftime($format, $dt->format('U'));
        }

        return $dt->format($format);

    }

    /**
     * Get the [strasse] column value.
     *
     * @return string
     */
    public function getStrasse()
    {

        return $this->strasse;
    }

    /**
     * Get the [plz] column value.
     *
     * @return string
     */
    public function getPlz()
    {

        return $this->plz;
    }

    /**
     * Get the [ort] column value.
     *
     * @return string
     */
    public function getOrt()
    {

        return $this->ort;
    }

    /**
     * Get the [iban] column value.
     *
     * @return string
     */
    public function getIban()
    {

        return $this->iban;
    }

    /**
     * Get the [bank] column value.
     *
     * @return string
     */
    public function getBank()
    {

        return $this->bank;
    }

    /**
     * Get the [email] column value.
     *
     * @return string
     */
    public function getEmail()
    {

        return $this->email;
    }

    /**
     * Get the [basis_betrag] column value.
     *
     * @return string
     */
    public function getBasisBetrag()
    {

        return $this->basis_betrag;
    }

    /**
     * Get the [steuermerkmal] column value.
     *
     * @return string
     */
    public function getSteuermerkmal()
    {

        return $this->steuermerkmal;
    }

    /**
     * Get the [aktiv] column value.
     *
     * @return boolean
     */
    public function getAktiv()
    {

        return $this->aktiv;
    }

    /**
     * Get the [lp_id] column value.
     *
     * @return int
     */
    public function getLpId()
    {

        return $this->lp_id;
    }

    /**
     * Set the value of [id] column.
     *
     * @param  int $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::ID;
        }


        return $this;
    } // setId()

    /**
     * Set the value of [mod] column.
     *
     * @param  int $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setMod($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->mod !== $v) {
            $this->mod = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::MOD;
        }


        return $this;
    } // setMod()

    /**
     * Set the value of [nachname] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setNachname($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->nachname !== $v) {
            $this->nachname = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::NACHNAME;
        }


        return $this;
    } // setNachname()

    /**
     * Set the value of [vorname] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setVorname($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->vorname !== $v) {
            $this->vorname = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::VORNAME;
        }


        return $this;
    } // setVorname()

    /**
     * Set the value of [anrede] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setAnrede($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->anrede !== $v) {
            $this->anrede = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::ANREDE;
        }


        return $this;
    } // setAnrede()

    /**
     * Sets the value of [gebdat] column to a normalized version of the date/time value specified.
     *
     * @param mixed $v string, integer (timestamp), or DateTime value.
     *               Empty strings are treated as null.
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setGebdat($v)
    {
        $dt = PropelDateTime::newInstance($v, null, 'DateTime');
        if ($this->gebdat !== null || $dt !== null) {
            $currentDateAsString = ($this->gebdat !== null && $tmpDt = new DateTime($this->gebdat)) ? $tmpDt->format('Y-m-d') : null;
            $newDateAsString = $dt ? $dt->format('Y-m-d') : null;
            if ($currentDateAsString !== $newDateAsString) {
                $this->gebdat = $newDateAsString;
                $this->modifiedColumns[] = MitarbeiterPeer::GEBDAT;
            }
        } // if either are not null


        return $this;
    } // setGebdat()

    /**
     * Set the value of [soz_ver_num] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setSozVerNum($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->soz_ver_num !== $v) {
            $this->soz_ver_num = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::SOZ_VER_NUM;
        }


        return $this;
    } // setSozVerNum()

    /**
     * Set the value of [steuerid] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setSteuerid($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->steuerid !== $v) {
            $this->steuerid = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::STEUERID;
        }


        return $this;
    } // setSteuerid()

    /**
     * Sets the value of [besch_beg] column to a normalized version of the date/time value specified.
     *
     * @param mixed $v string, integer (timestamp), or DateTime value.
     *               Empty strings are treated as null.
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setBeschBeg($v)
    {
        $dt = PropelDateTime::newInstance($v, null, 'DateTime');
        if ($this->besch_beg !== null || $dt !== null) {
            $currentDateAsString = ($this->besch_beg !== null && $tmpDt = new DateTime($this->besch_beg)) ? $tmpDt->format('Y-m-d') : null;
            $newDateAsString = $dt ? $dt->format('Y-m-d') : null;
            if ($currentDateAsString !== $newDateAsString) {
                $this->besch_beg = $newDateAsString;
                $this->modifiedColumns[] = MitarbeiterPeer::BESCH_BEG;
            }
        } // if either are not null


        return $this;
    } // setBeschBeg()

    /**
     * Set the value of [strasse] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setStrasse($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->strasse !== $v) {
            $this->strasse = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::STRASSE;
        }


        return $this;
    } // setStrasse()

    /**
     * Set the value of [plz] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setPlz($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->plz !== $v) {
            $this->plz = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::PLZ;
        }


        return $this;
    } // setPlz()

    /**
     * Set the value of [ort] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setOrt($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->ort !== $v) {
            $this->ort = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::ORT;
        }


        return $this;
    } // setOrt()

    /**
     * Set the value of [iban] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setIban($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->iban !== $v) {
            $this->iban = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::IBAN;
        }


        return $this;
    } // setIban()

    /**
     * Set the value of [bank] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setBank($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->bank !== $v) {
            $this->bank = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::BANK;
        }


        return $this;
    } // setBank()

    /**
     * Set the value of [email] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setEmail($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->email !== $v) {
            $this->email = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::EMAIL;
        }


        return $this;
    } // setEmail()

    /**
     * Set the value of [basis_betrag] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setBasisBetrag($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (string) $v;
        }

        if ($this->basis_betrag !== $v) {
            $this->basis_betrag = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::BASIS_BETRAG;
        }


        return $this;
    } // setBasisBetrag()

    /**
     * Set the value of [steuermerkmal] column.
     *
     * @param  string $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setSteuermerkmal($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->steuermerkmal !== $v) {
            $this->steuermerkmal = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::STEUERMERKMAL;
        }


        return $this;
    } // setSteuermerkmal()

    /**
     * Sets the value of the [aktiv] column.
     * Non-boolean arguments are converted using the following rules:
     *   * 1, '1', 'true',  'on',  and 'yes' are converted to boolean true
     *   * 0, '0', 'false', 'off', and 'no'  are converted to boolean false
     * Check on string values is case insensitive (so 'FaLsE' is seen as 'false').
     *
     * @param boolean|integer|string $v The new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setAktiv($v)
    {
        if ($v !== null) {
            if (is_string($v)) {
                $v = in_array(strtolower($v), array('false', 'off', '-', 'no', 'n', '0', '')) ? false : true;
            } else {
                $v = (boolean) $v;
            }
        }

        if ($this->aktiv !== $v) {
            $this->aktiv = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::AKTIV;
        }


        return $this;
    } // setAktiv()

    /**
     * Set the value of [lp_id] column.
     *
     * @param  int $v new value
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setLpId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->lp_id !== $v) {
            $this->lp_id = $v;
            $this->modifiedColumns[] = MitarbeiterPeer::LP_ID;
        }

        if ($this->aLohnprofil !== null && $this->aLohnprofil->getId() !== $v) {
            $this->aLohnprofil = null;
        }


        return $this;
    } // setLpId()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
            if ($this->basis_betrag !== '0') {
                return false;
            }

        // otherwise, everything was equal, so return true
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
     * @param int $startcol 0-based offset column which indicates which resultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false)
    {
        try {

            $this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
            $this->mod = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
            $this->nachname = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
            $this->vorname = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
            $this->anrede = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
            $this->gebdat = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
            $this->soz_ver_num = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
            $this->steuerid = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
            $this->besch_beg = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
            $this->strasse = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
            $this->plz = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
            $this->ort = ($row[$startcol + 11] !== null) ? (string) $row[$startcol + 11] : null;
            $this->iban = ($row[$startcol + 12] !== null) ? (string) $row[$startcol + 12] : null;
            $this->bank = ($row[$startcol + 13] !== null) ? (string) $row[$startcol + 13] : null;
            $this->email = ($row[$startcol + 14] !== null) ? (string) $row[$startcol + 14] : null;
            $this->basis_betrag = ($row[$startcol + 15] !== null) ? (string) $row[$startcol + 15] : null;
            $this->steuermerkmal = ($row[$startcol + 16] !== null) ? (string) $row[$startcol + 16] : null;
            $this->aktiv = ($row[$startcol + 17] !== null) ? (boolean) $row[$startcol + 17] : null;
            $this->lp_id = ($row[$startcol + 18] !== null) ? (int) $row[$startcol + 18] : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }
            $this->postHydrate($row, $startcol, $rehydrate);

            return $startcol + 19; // 19 = MitarbeiterPeer::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException("Error populating Mitarbeiter object", $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {

        if ($this->aLohnprofil !== null && $this->lp_id !== $this->aLohnprofil->getId()) {
            $this->aLohnprofil = null;
        }
    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param boolean $deep (optional) Whether to also de-associated any related objects.
     * @param PropelPDO $con (optional) The PropelPDO connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getConnection(MitarbeiterPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $stmt = MitarbeiterPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
        $row = $stmt->fetch(PDO::FETCH_NUM);
        $stmt->closeCursor();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->aLohnprofil = null;
            $this->collLAs = null;

        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param PropelPDO $con
     * @return void
     * @throws PropelException
     * @throws Exception
     * @see        BaseObject::setDeleted()
     * @see        BaseObject::isDeleted()
     */
    public function delete(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(MitarbeiterPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        try {
            $deleteQuery = MitarbeiterQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $con->commit();
                $this->setDeleted(true);
            } else {
                $con->commit();
            }
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @throws Exception
     * @see        doSave()
     */
    public function save(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(MitarbeiterPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        $isInsert = $this->isNew();
        try {
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                MitarbeiterPeer::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see        save()
     */
    protected function doSave(PropelPDO $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aLohnprofil !== null) {
                if ($this->aLohnprofil->isModified() || $this->aLohnprofil->isNew()) {
                    $affectedRows += $this->aLohnprofil->save($con);
                }
                $this->setLohnprofil($this->aLohnprofil);
            }

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                } else {
                    $this->doUpdate($con);
                }
                $affectedRows += 1;
                $this->resetModified();
            }

            if ($this->lAsScheduledForDeletion !== null) {
                if (!$this->lAsScheduledForDeletion->isEmpty()) {
                    LohnabrechnungQuery::create()
                        ->filterByPrimaryKeys($this->lAsScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->lAsScheduledForDeletion = null;
                }
            }

            if ($this->collLAs !== null) {
                foreach ($this->collLAs as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param PropelPDO $con
     *
     * @throws PropelException
     * @see        doSave()
     */
    protected function doInsert(PropelPDO $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[] = MitarbeiterPeer::ID;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . MitarbeiterPeer::ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(MitarbeiterPeer::ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::MOD)) {
            $modifiedColumns[':p' . $index++]  = '`mod`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::NACHNAME)) {
            $modifiedColumns[':p' . $index++]  = '`nachname`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::VORNAME)) {
            $modifiedColumns[':p' . $index++]  = '`vorname`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::ANREDE)) {
            $modifiedColumns[':p' . $index++]  = '`anrede`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::GEBDAT)) {
            $modifiedColumns[':p' . $index++]  = '`gebdat`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::SOZ_VER_NUM)) {
            $modifiedColumns[':p' . $index++]  = '`soz_ver_num`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::STEUERID)) {
            $modifiedColumns[':p' . $index++]  = '`steuerid`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::BESCH_BEG)) {
            $modifiedColumns[':p' . $index++]  = '`besch_beg`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::STRASSE)) {
            $modifiedColumns[':p' . $index++]  = '`strasse`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::PLZ)) {
            $modifiedColumns[':p' . $index++]  = '`plz`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::ORT)) {
            $modifiedColumns[':p' . $index++]  = '`ort`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::IBAN)) {
            $modifiedColumns[':p' . $index++]  = '`iban`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::BANK)) {
            $modifiedColumns[':p' . $index++]  = '`bank`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::EMAIL)) {
            $modifiedColumns[':p' . $index++]  = '`email`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::BASIS_BETRAG)) {
            $modifiedColumns[':p' . $index++]  = '`basis_betrag`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::STEUERMERKMAL)) {
            $modifiedColumns[':p' . $index++]  = '`steuermerkmal`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::AKTIV)) {
            $modifiedColumns[':p' . $index++]  = '`aktiv`';
        }
        if ($this->isColumnModified(MitarbeiterPeer::LP_ID)) {
            $modifiedColumns[':p' . $index++]  = '`lp_id`';
        }

        $sql = sprintf(
            'INSERT INTO `mitarbeiter` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`mod`':
                        $stmt->bindValue($identifier, $this->mod, PDO::PARAM_INT);
                        break;
                    case '`nachname`':
                        $stmt->bindValue($identifier, $this->nachname, PDO::PARAM_STR);
                        break;
                    case '`vorname`':
                        $stmt->bindValue($identifier, $this->vorname, PDO::PARAM_STR);
                        break;
                    case '`anrede`':
                        $stmt->bindValue($identifier, $this->anrede, PDO::PARAM_STR);
                        break;
                    case '`gebdat`':
                        $stmt->bindValue($identifier, $this->gebdat, PDO::PARAM_STR);
                        break;
                    case '`soz_ver_num`':
                        $stmt->bindValue($identifier, $this->soz_ver_num, PDO::PARAM_STR);
                        break;
                    case '`steuerid`':
                        $stmt->bindValue($identifier, $this->steuerid, PDO::PARAM_STR);
                        break;
                    case '`besch_beg`':
                        $stmt->bindValue($identifier, $this->besch_beg, PDO::PARAM_STR);
                        break;
                    case '`strasse`':
                        $stmt->bindValue($identifier, $this->strasse, PDO::PARAM_STR);
                        break;
                    case '`plz`':
                        $stmt->bindValue($identifier, $this->plz, PDO::PARAM_STR);
                        break;
                    case '`ort`':
                        $stmt->bindValue($identifier, $this->ort, PDO::PARAM_STR);
                        break;
                    case '`iban`':
                        $stmt->bindValue($identifier, $this->iban, PDO::PARAM_STR);
                        break;
                    case '`bank`':
                        $stmt->bindValue($identifier, $this->bank, PDO::PARAM_STR);
                        break;
                    case '`email`':
                        $stmt->bindValue($identifier, $this->email, PDO::PARAM_STR);
                        break;
                    case '`basis_betrag`':
                        $stmt->bindValue($identifier, $this->basis_betrag, PDO::PARAM_INT);
                        break;
                    case '`steuermerkmal`':
                        $stmt->bindValue($identifier, $this->steuermerkmal, PDO::PARAM_STR);
                        break;
                    case '`aktiv`':
                        $stmt->bindValue($identifier, (int) $this->aktiv, PDO::PARAM_INT);
                        break;
                    case '`lp_id`':
                        $stmt->bindValue($identifier, $this->lp_id, PDO::PARAM_INT);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param PropelPDO $con
     *
     * @see        doSave()
     */
    protected function doUpdate(PropelPDO $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();
        BasePeer::doUpdate($selectCriteria, $valuesCriteria, $con);
    }

    /**
     * Array of ValidationFailed objects.
     * @var        array ValidationFailed[]
     */
    protected $validationFailures = array();

    /**
     * Gets any ValidationFailed objects that resulted from last call to validate().
     *
     *
     * @return array ValidationFailed[]
     * @see        validate()
     */
    public function getValidationFailures()
    {
        return $this->validationFailures;
    }

    /**
     * Validates the objects modified field values and all objects related to this table.
     *
     * If $columns is either a column name or an array of column names
     * only those columns are validated.
     *
     * @param mixed $columns Column name or an array of column names.
     * @return boolean Whether all columns pass validation.
     * @see        doValidate()
     * @see        getValidationFailures()
     */
    public function validate($columns = null)
    {
        $res = $this->doValidate($columns);
        if ($res === true) {
            $this->validationFailures = array();

            return true;
        }

        $this->validationFailures = $res;

        return false;
    }

    /**
     * This function performs the validation work for complex object models.
     *
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggregated array of ValidationFailed objects will be returned.
     *
     * @param array $columns Array of column names to validate.
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objects otherwise.
     */
    protected function doValidate($columns = null)
    {
        if (!$this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;

            $failureMap = array();


            // We call the validate method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aLohnprofil !== null) {
                if (!$this->aLohnprofil->validate($columns)) {
                    $failureMap = array_merge($failureMap, $this->aLohnprofil->getValidationFailures());
                }
            }


            if (($retval = MitarbeiterPeer::doValidate($this, $columns)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }


                if ($this->collLAs !== null) {
                    foreach ($this->collLAs as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }


            $this->alreadyInValidation = false;
        }

        return (!empty($failureMap) ? $failureMap : true);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param string $name name
     * @param string $type The type of fieldname the $name is of:
     *               one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *               BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *               Defaults to BasePeer::TYPE_PHPNAME
     * @return mixed Value of field.
     */
    public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = MitarbeiterPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getMod();
                break;
            case 2:
                return $this->getNachname();
                break;
            case 3:
                return $this->getVorname();
                break;
            case 4:
                return $this->getAnrede();
                break;
            case 5:
                return $this->getGebdat();
                break;
            case 6:
                return $this->getSozVerNum();
                break;
            case 7:
                return $this->getSteuerid();
                break;
            case 8:
                return $this->getBeschBeg();
                break;
            case 9:
                return $this->getStrasse();
                break;
            case 10:
                return $this->getPlz();
                break;
            case 11:
                return $this->getOrt();
                break;
            case 12:
                return $this->getIban();
                break;
            case 13:
                return $this->getBank();
                break;
            case 14:
                return $this->getEmail();
                break;
            case 15:
                return $this->getBasisBetrag();
                break;
            case 16:
                return $this->getSteuermerkmal();
                break;
            case 17:
                return $this->getAktiv();
                break;
            case 18:
                return $this->getLpId();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     *                    BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                    Defaults to BasePeer::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to true.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {
        if (isset($alreadyDumpedObjects['Mitarbeiter'][$this->getPrimaryKey()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['Mitarbeiter'][$this->getPrimaryKey()] = true;
        $keys = MitarbeiterPeer::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getMod(),
            $keys[2] => $this->getNachname(),
            $keys[3] => $this->getVorname(),
            $keys[4] => $this->getAnrede(),
            $keys[5] => $this->getGebdat(),
            $keys[6] => $this->getSozVerNum(),
            $keys[7] => $this->getSteuerid(),
            $keys[8] => $this->getBeschBeg(),
            $keys[9] => $this->getStrasse(),
            $keys[10] => $this->getPlz(),
            $keys[11] => $this->getOrt(),
            $keys[12] => $this->getIban(),
            $keys[13] => $this->getBank(),
            $keys[14] => $this->getEmail(),
            $keys[15] => $this->getBasisBetrag(),
            $keys[16] => $this->getSteuermerkmal(),
            $keys[17] => $this->getAktiv(),
            $keys[18] => $this->getLpId(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->aLohnprofil) {
                $result['Lohnprofil'] = $this->aLohnprofil->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
            if (null !== $this->collLAs) {
                $result['LAs'] = $this->collLAs->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param string $name peer name
     * @param mixed $value field value
     * @param string $type The type of fieldname the $name is of:
     *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                     Defaults to BasePeer::TYPE_PHPNAME
     * @return void
     */
    public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = MitarbeiterPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);

        $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @param mixed $value field value
     * @return void
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setMod($value);
                break;
            case 2:
                $this->setNachname($value);
                break;
            case 3:
                $this->setVorname($value);
                break;
            case 4:
                $this->setAnrede($value);
                break;
            case 5:
                $this->setGebdat($value);
                break;
            case 6:
                $this->setSozVerNum($value);
                break;
            case 7:
                $this->setSteuerid($value);
                break;
            case 8:
                $this->setBeschBeg($value);
                break;
            case 9:
                $this->setStrasse($value);
                break;
            case 10:
                $this->setPlz($value);
                break;
            case 11:
                $this->setOrt($value);
                break;
            case 12:
                $this->setIban($value);
                break;
            case 13:
                $this->setBank($value);
                break;
            case 14:
                $this->setEmail($value);
                break;
            case 15:
                $this->setBasisBetrag($value);
                break;
            case 16:
                $this->setSteuermerkmal($value);
                break;
            case 17:
                $this->setAktiv($value);
                break;
            case 18:
                $this->setLpId($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     * The default key type is the column's BasePeer::TYPE_PHPNAME
     *
     * @param array  $arr     An array to populate the object from.
     * @param string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
    {
        $keys = MitarbeiterPeer::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
        if (array_key_exists($keys[1], $arr)) $this->setMod($arr[$keys[1]]);
        if (array_key_exists($keys[2], $arr)) $this->setNachname($arr[$keys[2]]);
        if (array_key_exists($keys[3], $arr)) $this->setVorname($arr[$keys[3]]);
        if (array_key_exists($keys[4], $arr)) $this->setAnrede($arr[$keys[4]]);
        if (array_key_exists($keys[5], $arr)) $this->setGebdat($arr[$keys[5]]);
        if (array_key_exists($keys[6], $arr)) $this->setSozVerNum($arr[$keys[6]]);
        if (array_key_exists($keys[7], $arr)) $this->setSteuerid($arr[$keys[7]]);
        if (array_key_exists($keys[8], $arr)) $this->setBeschBeg($arr[$keys[8]]);
        if (array_key_exists($keys[9], $arr)) $this->setStrasse($arr[$keys[9]]);
        if (array_key_exists($keys[10], $arr)) $this->setPlz($arr[$keys[10]]);
        if (array_key_exists($keys[11], $arr)) $this->setOrt($arr[$keys[11]]);
        if (array_key_exists($keys[12], $arr)) $this->setIban($arr[$keys[12]]);
        if (array_key_exists($keys[13], $arr)) $this->setBank($arr[$keys[13]]);
        if (array_key_exists($keys[14], $arr)) $this->setEmail($arr[$keys[14]]);
        if (array_key_exists($keys[15], $arr)) $this->setBasisBetrag($arr[$keys[15]]);
        if (array_key_exists($keys[16], $arr)) $this->setSteuermerkmal($arr[$keys[16]]);
        if (array_key_exists($keys[17], $arr)) $this->setAktiv($arr[$keys[17]]);
        if (array_key_exists($keys[18], $arr)) $this->setLpId($arr[$keys[18]]);
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(MitarbeiterPeer::DATABASE_NAME);

        if ($this->isColumnModified(MitarbeiterPeer::ID)) $criteria->add(MitarbeiterPeer::ID, $this->id);
        if ($this->isColumnModified(MitarbeiterPeer::MOD)) $criteria->add(MitarbeiterPeer::MOD, $this->mod);
        if ($this->isColumnModified(MitarbeiterPeer::NACHNAME)) $criteria->add(MitarbeiterPeer::NACHNAME, $this->nachname);
        if ($this->isColumnModified(MitarbeiterPeer::VORNAME)) $criteria->add(MitarbeiterPeer::VORNAME, $this->vorname);
        if ($this->isColumnModified(MitarbeiterPeer::ANREDE)) $criteria->add(MitarbeiterPeer::ANREDE, $this->anrede);
        if ($this->isColumnModified(MitarbeiterPeer::GEBDAT)) $criteria->add(MitarbeiterPeer::GEBDAT, $this->gebdat);
        if ($this->isColumnModified(MitarbeiterPeer::SOZ_VER_NUM)) $criteria->add(MitarbeiterPeer::SOZ_VER_NUM, $this->soz_ver_num);
        if ($this->isColumnModified(MitarbeiterPeer::STEUERID)) $criteria->add(MitarbeiterPeer::STEUERID, $this->steuerid);
        if ($this->isColumnModified(MitarbeiterPeer::BESCH_BEG)) $criteria->add(MitarbeiterPeer::BESCH_BEG, $this->besch_beg);
        if ($this->isColumnModified(MitarbeiterPeer::STRASSE)) $criteria->add(MitarbeiterPeer::STRASSE, $this->strasse);
        if ($this->isColumnModified(MitarbeiterPeer::PLZ)) $criteria->add(MitarbeiterPeer::PLZ, $this->plz);
        if ($this->isColumnModified(MitarbeiterPeer::ORT)) $criteria->add(MitarbeiterPeer::ORT, $this->ort);
        if ($this->isColumnModified(MitarbeiterPeer::IBAN)) $criteria->add(MitarbeiterPeer::IBAN, $this->iban);
        if ($this->isColumnModified(MitarbeiterPeer::BANK)) $criteria->add(MitarbeiterPeer::BANK, $this->bank);
        if ($this->isColumnModified(MitarbeiterPeer::EMAIL)) $criteria->add(MitarbeiterPeer::EMAIL, $this->email);
        if ($this->isColumnModified(MitarbeiterPeer::BASIS_BETRAG)) $criteria->add(MitarbeiterPeer::BASIS_BETRAG, $this->basis_betrag);
        if ($this->isColumnModified(MitarbeiterPeer::STEUERMERKMAL)) $criteria->add(MitarbeiterPeer::STEUERMERKMAL, $this->steuermerkmal);
        if ($this->isColumnModified(MitarbeiterPeer::AKTIV)) $criteria->add(MitarbeiterPeer::AKTIV, $this->aktiv);
        if ($this->isColumnModified(MitarbeiterPeer::LP_ID)) $criteria->add(MitarbeiterPeer::LP_ID, $this->lp_id);

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(MitarbeiterPeer::DATABASE_NAME);
        $criteria->add(MitarbeiterPeer::ID, $this->id);

        return $criteria;
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param  int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {

        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param object $copyObj An object of Mitarbeiter (or compatible) type.
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setMod($this->getMod());
        $copyObj->setNachname($this->getNachname());
        $copyObj->setVorname($this->getVorname());
        $copyObj->setAnrede($this->getAnrede());
        $copyObj->setGebdat($this->getGebdat());
        $copyObj->setSozVerNum($this->getSozVerNum());
        $copyObj->setSteuerid($this->getSteuerid());
        $copyObj->setBeschBeg($this->getBeschBeg());
        $copyObj->setStrasse($this->getStrasse());
        $copyObj->setPlz($this->getPlz());
        $copyObj->setOrt($this->getOrt());
        $copyObj->setIban($this->getIban());
        $copyObj->setBank($this->getBank());
        $copyObj->setEmail($this->getEmail());
        $copyObj->setBasisBetrag($this->getBasisBetrag());
        $copyObj->setSteuermerkmal($this->getSteuermerkmal());
        $copyObj->setAktiv($this->getAktiv());
        $copyObj->setLpId($this->getLpId());

        if ($deepCopy && !$this->startCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);
            // store object hash to prevent cycle
            $this->startCopy = true;

            foreach ($this->getLAs() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addLA($relObj->copy($deepCopy));
                }
            }

            //unflag object copy
            $this->startCopy = false;
        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return Mitarbeiter Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Returns a peer instance associated with this om.
     *
     * Since Peer classes are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     *
     * @return MitarbeiterPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new MitarbeiterPeer();
        }

        return self::$peer;
    }

    /**
     * Declares an association between this object and a Lohnprofil object.
     *
     * @param                  Lohnprofil $v
     * @return Mitarbeiter The current object (for fluent API support)
     * @throws PropelException
     */
    public function setLohnprofil(Lohnprofil $v = null)
    {
        if ($v === null) {
            $this->setLpId(NULL);
        } else {
            $this->setLpId($v->getId());
        }

        $this->aLohnprofil = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the Lohnprofil object, it will not be re-added.
        if ($v !== null) {
            $v->addMA($this);
        }


        return $this;
    }


    /**
     * Get the associated Lohnprofil object
     *
     * @param PropelPDO $con Optional Connection object.
     * @param $doQuery Executes a query to get the object if required
     * @return Lohnprofil The associated Lohnprofil object.
     * @throws PropelException
     */
    public function getLohnprofil(PropelPDO $con = null, $doQuery = true)
    {
        if ($this->aLohnprofil === null && ($this->lp_id !== null) && $doQuery) {
            $this->aLohnprofil = LohnprofilQuery::create()->findPk($this->lp_id, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aLohnprofil->addMAs($this);
             */
        }

        return $this->aLohnprofil;
    }


    /**
     * Initializes a collection based on the name of a relation.
     * Avoids crafting an 'init[$relationName]s' method name
     * that wouldn't work when StandardEnglishPluralizer is used.
     *
     * @param string $relationName The name of the relation to initialize
     * @return void
     */
    public function initRelation($relationName)
    {
        if ('LA' == $relationName) {
            $this->initLAs();
        }
    }

    /**
     * Clears out the collLAs collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return Mitarbeiter The current object (for fluent API support)
     * @see        addLAs()
     */
    public function clearLAs()
    {
        $this->collLAs = null; // important to set this to null since that means it is uninitialized
        $this->collLAsPartial = null;

        return $this;
    }

    /**
     * reset is the collLAs collection loaded partially
     *
     * @return void
     */
    public function resetPartialLAs($v = true)
    {
        $this->collLAsPartial = $v;
    }

    /**
     * Initializes the collLAs collection.
     *
     * By default this just sets the collLAs collection to an empty array (like clearcollLAs());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initLAs($overrideExisting = true)
    {
        if (null !== $this->collLAs && !$overrideExisting) {
            return;
        }
        $this->collLAs = new PropelObjectCollection();
        $this->collLAs->setModel('Lohnabrechnung');
    }

    /**
     * Gets an array of Lohnabrechnung objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this Mitarbeiter is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|Lohnabrechnung[] List of Lohnabrechnung objects
     * @throws PropelException
     */
    public function getLAs($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collLAsPartial && !$this->isNew();
        if (null === $this->collLAs || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collLAs) {
                // return empty collection
                $this->initLAs();
            } else {
                $collLAs = LohnabrechnungQuery::create(null, $criteria)
                    ->filterByMitarbeiter($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collLAsPartial && count($collLAs)) {
                      $this->initLAs(false);

                      foreach ($collLAs as $obj) {
                        if (false == $this->collLAs->contains($obj)) {
                          $this->collLAs->append($obj);
                        }
                      }

                      $this->collLAsPartial = true;
                    }

                    $collLAs->getInternalIterator()->rewind();

                    return $collLAs;
                }

                if ($partial && $this->collLAs) {
                    foreach ($this->collLAs as $obj) {
                        if ($obj->isNew()) {
                            $collLAs[] = $obj;
                        }
                    }
                }

                $this->collLAs = $collLAs;
                $this->collLAsPartial = false;
            }
        }

        return $this->collLAs;
    }

    /**
     * Sets a collection of LA objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $lAs A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function setLAs(PropelCollection $lAs, PropelPDO $con = null)
    {
        $lAsToDelete = $this->getLAs(new Criteria(), $con)->diff($lAs);


        $this->lAsScheduledForDeletion = $lAsToDelete;

        foreach ($lAsToDelete as $lARemoved) {
            $lARemoved->setMitarbeiter(null);
        }

        $this->collLAs = null;
        foreach ($lAs as $lA) {
            $this->addLA($lA);
        }

        $this->collLAs = $lAs;
        $this->collLAsPartial = false;

        return $this;
    }

    /**
     * Returns the number of related Lohnabrechnung objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related Lohnabrechnung objects.
     * @throws PropelException
     */
    public function countLAs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collLAsPartial && !$this->isNew();
        if (null === $this->collLAs || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collLAs) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getLAs());
            }
            $query = LohnabrechnungQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByMitarbeiter($this)
                ->count($con);
        }

        return count($this->collLAs);
    }

    /**
     * Method called to associate a BaseLohnabrechnung object to this object
     * through the BaseLohnabrechnung foreign key attribute.
     *
     * @param    BaseLohnabrechnung $l BaseLohnabrechnung
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function addLA(BaseLohnabrechnung $l)
    {
        if ($this->collLAs === null) {
            $this->initLAs();
            $this->collLAsPartial = true;
        }

        if (!in_array($l, $this->collLAs->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddLA($l);

            if ($this->lAsScheduledForDeletion and $this->lAsScheduledForDeletion->contains($l)) {
                $this->lAsScheduledForDeletion->remove($this->lAsScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	LA $lA The lA object to add.
     */
    protected function doAddLA($lA)
    {
        $this->collLAs[]= $lA;
        $lA->setMitarbeiter($this);
    }

    /**
     * @param	LA $lA The lA object to remove.
     * @return Mitarbeiter The current object (for fluent API support)
     */
    public function removeLA($lA)
    {
        if ($this->getLAs()->contains($lA)) {
            $this->collLAs->remove($this->collLAs->search($lA));
            if (null === $this->lAsScheduledForDeletion) {
                $this->lAsScheduledForDeletion = clone $this->collLAs;
                $this->lAsScheduledForDeletion->clear();
            }
            $this->lAsScheduledForDeletion[]= clone $lA;
            $lA->setMitarbeiter(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Mitarbeiter is new, it will return
     * an empty collection; or if this Mitarbeiter has previously
     * been saved, it will retrieve related LAs from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Mitarbeiter.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @param string $join_behavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return PropelObjectCollection|Lohnabrechnung[] List of Lohnabrechnung objects
     */
    public function getLAsJoinLohnprofil($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $query = LohnabrechnungQuery::create(null, $criteria);
        $query->joinWith('Lohnprofil', $join_behavior);

        return $this->getLAs($query, $con);
    }

    /**
     * Clears the current object and sets all attributes to their default values
     */
    public function clear()
    {
        $this->id = null;
        $this->mod = null;
        $this->nachname = null;
        $this->vorname = null;
        $this->anrede = null;
        $this->gebdat = null;
        $this->soz_ver_num = null;
        $this->steuerid = null;
        $this->besch_beg = null;
        $this->strasse = null;
        $this->plz = null;
        $this->ort = null;
        $this->iban = null;
        $this->bank = null;
        $this->email = null;
        $this->basis_betrag = null;
        $this->steuermerkmal = null;
        $this->aktiv = null;
        $this->lp_id = null;
        $this->alreadyInSave = false;
        $this->alreadyInValidation = false;
        $this->alreadyInClearAllReferencesDeep = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references to other model objects or collections of model objects.
     *
     * This method is a user-space workaround for PHP's inability to garbage collect
     * objects with circular references (even in PHP 5.3). This is currently necessary
     * when using Propel in certain daemon or large-volume/high-memory operations.
     *
     * @param boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep && !$this->alreadyInClearAllReferencesDeep) {
            $this->alreadyInClearAllReferencesDeep = true;
            if ($this->collLAs) {
                foreach ($this->collLAs as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->aLohnprofil instanceof Persistent) {
              $this->aLohnprofil->clearAllReferences($deep);
            }

            $this->alreadyInClearAllReferencesDeep = false;
        } // if ($deep)

        if ($this->collLAs instanceof PropelCollection) {
            $this->collLAs->clearIterator();
        }
        $this->collLAs = null;
        $this->aLohnprofil = null;
    }

    /**
     * return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(MitarbeiterPeer::DEFAULT_STRING_FORMAT);
    }

    /**
     * return true is the object is in saving state
     *
     * @return boolean
     */
    public function isAlreadyInSave()
    {
        return $this->alreadyInSave;
    }

}
