<?php
// define user
$user = getenv("USER");
if ($user == "") putenv("USER=gui");

// includes
$path = preg_replace("/mLohn.*/", "mLohn", __FILE__);
set_include_path($path . PATH_SEPARATOR . get_include_path());
require_once 'gui/control/LohnControl.php';
require_once 'util/Logger.php';
require_once 'util/error_codes.php';

// Logging
$logger = Logger::getInstance();

try {
    // load configuration + class loader
    include 'gui/control/ConfigurationData.php';
    Config::setConfiguration($configurationData);
    
    // security check
    $config = Config::getInstance();
    if (! $config->getConfig("Testbetrieb")) {
        if (! isset($_SERVER["HTTPS"])) {
            $logger->log(__FILE__, "kein HTTPS");
            header("Location: https://".$_SERVER["SERVER_NAME"]."/mlohn/gui/", 301);
            exit;
        }
        if (!isset($_SERVER["AUTH_TYPE"])) {
            $logger->log(__FILE__, "No authentification");
            header("Location: /mlohn/view/view/error_view.php?code=".INVALID_AUTH);
        }
    }
    
    // Log request
    $requestMethod = $_SERVER["REQUEST_METHOD"];
    $logger->log(__FILE__, $requestMethod);
    if ($requestMethod == "GET") {
        $logger->log(__FILE__, "GET-Variabeles:");
        foreach ( $_GET as $key => $value ) {
        	$logger->log(__FILE__, $key . " : " . $value);;
        }
    }
    else {
        $logger->log(__FILE__, "POST-Variabeles:");
        foreach ( $_POST as $key => $value ) {
        	$logger->log(__FILE__, $key . " : " . $value);;
        }
    }
    $logger->log(__FILE__,"Redirect-URL:".$_SERVER["REDIRECT_URL"]);

    // call implementation
	$control = new LohnControl();
	$control->doIt();
}
catch (Exception $e) {
	$logger->logException(__FILE__, $e);	
	echo "<html><body>Error occurred!</body></html>";
}

